////////////////////////////////////////////////////////////////////////////////
//File:PlayerDlg.cpp 
/////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "Player.h"
#include "PlayerDlg.h"
#include "mmsystem.h"
#include "vkey.h"
#include "proplaympeg4.h"
#include "info.h"
#include "cutfile.h"

#include "AVIFMt.H"
#include "WRIFF.H"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL g_bCapPic=FALSE;				
UINT WM_FILE_END=WM_USER +33;		//User message. Be posted when the file is end.
UINT WM_ENC_CHANGE=WM_USER +100; 
UINT PLAY_TIMER	=1;					//TIMER ID;
UINT PORT=0;	//uesed port;can be from 0 to 15;

					
#define WRITE_REC_LIST

#define WRITE_INDEX

#define ALIGN_VIDEO_FRAMES

//////////////////////////////////////////////////////////////////////////////

#define FORMAT_CIF        //If Want to Convert 4cif or qcif Format to AVI File,
                           //Please Redefine this MACRO

#ifdef FORMAT_CIF          //CIF Format
#define MAX_FRAMES 13980   //If the Converted Frame Number  are Larger than MAX_FRAMES
#endif                     // the AVI File will exceed 2G

#ifdef FORMAT_4CIF         //4CIF Format
#define MAX_FRAMES 3518   
#endif

#ifdef FORMAT_QCIF         //QCIF Format
#define MAX_FRAMES 55180
#endif

#ifdef FORMAT_2CIF         //2CIF Format
#define MAX_FRAMES 7035
#endif
///////////////////////////////////////////////////////////////////////////////

#define PADDING_GRANULARITY 2048

BOOL				 m_bConvert=FALSE;
CString				 szFileName;
BOOL				 m_bFirstWrite=FALSE;
BOOL				 m_bFirst=FALSE;
int                  frameNum=0;
char				 *yuvBuf;
riffFile			 *outFile;
long				 numFrames;
long				 frameWidth;
long				 frameHeight;
long				 fps;
long				 maxFrameSize;

int					 Y_PLANE_SIZE;
//int				 U4_PLANE_SIZE;
//int				 V4_PLANE_SIZE;
int					 U2_PLANE_SIZE;
int					 V2_PLANE_SIZE;

int					 inputFrameSize;
int					 outputFrameSize;
static int  pic=0;

#ifdef WRITE_INDEX
AVIINDEXENTRY		 indexes[MAX_FRAMES];
long				 moviOffset;
#endif // WRITE_INDEX
long				 firstFrameOffset;
//#define _FILE_POS
//#define _TEST_CALLBACK			//if defined only decode,and not display!
//#define WAVE_ADJ					//if defined will addjust the wave value, else will set the voluem of the sound card; 

#define WIDTH				352		//Initialize width;
#define HEIGHT_PAL			288		//Initialize height;

#define APP_VERSION			4.3   //3.6	//player version;
//Define the controls size and position;
#define PLAY_SLIDER_UP		10
#define PLAY_SLIDER_HEIGHT	20
#define BUTTON_UP			4
#define BUTTON_SIZE			20
#define STATE_UP			10
#define STATE_HEIGHT		23
#define PANNEL_HEIGHT		(STATE_HEIGHT+STATE_UP+BUTTON_SIZE+BUTTON_UP+2*(PLAY_SLIDER_HEIGHT+PLAY_SLIDER_UP))
#define INTERVAL_SIZE		2
#define INTERVAL			5
#define LEFT_EDGE			5
#define SOUND_SLIDER_HEIGHT	15
#define SOUND_SLIDER_WIDTH  60

//File locate reference call back function;
void CALLBACK FileRefDone(DWORD nReserved,DWORD nUser);
//capture call back function;
void CALLBACK DisplayCBFun(long nPort,char * pBuf,long nSize,long nWidth,long nHeight,long nStamp,long nType,long nReceaved);
//wave call back funtion
void CALLBACK WaveCBFun(long nPort, char * pAudioBuf, long nSize, long nStamp, long nType, long nUser);
//Decode call back funtion;
void CALLBACK DecCBFun(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, long nReserved1,long nReserved2);
void CALLBACK SourceBufFun(long nPort,DWORD nBufSize,DWORD dwUser,void*pContext);
// From v3.6; verify water mask;
void CALLBACK VerifyFun(long nPort, FRAME_POS * pFilePos, DWORD bIsVideo, DWORD nUser);
DWORD WINAPI InputStreamThread( LPVOID lpParameter);
void CALLBACK funEncChange(long nPort, long nUser); 
bool writeHeaders();
bool addFileToAVI(long frameNumber);
bool closeWriffFiles();
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	//ʾ汾Ϣ
	CString csVer;
	DWORD nVer=PlayM4_GetSdkVersion();
	DWORD nVersion=nVer&0x0000ffff;
	DWORD nBuild=(nVer>>16)&0x0000ffff;
	csVer.Format("ProPlayer ver is %.1f\n\rProPlayM4.dll ver is %04x build is %04x",APP_VERSION,nVersion,nBuild);
	GetDlgItem(IDC_VER)->SetWindowText(csVer);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerDlg dialog

CPlayerDlg::CPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlayerDlg)
	m_strPlayStateText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	
	m_hIcon =					AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hPlayEnableIcon =			AfxGetApp()->LoadIcon(IDI_PLAY_ENABLE);
	m_hPlayDisableIcon =		AfxGetApp()->LoadIcon(IDI_PLAY_DISABLE);
	m_hPauseEnableIcon =		AfxGetApp()->LoadIcon(IDI_PAUSE_ENABLE);
	m_hPauseDisableIcon =		AfxGetApp()->LoadIcon(IDI_PAUSE_DISABLE);
	m_hStopEnableIcon =			AfxGetApp()->LoadIcon(IDI_STOP_ENABLE);
	m_hStopDisableIcon =		AfxGetApp()->LoadIcon(IDI_STOP_DISABLE);
	m_hSoundStartIcon=			AfxGetApp()->LoadIcon(IDI_SOUND_ENABLE);
	m_hSoundStopIcon=			AfxGetApp()->LoadIcon(IDI_SOUND_DISABLE);
	m_hGotoStartDisableIcon =	AfxGetApp()->LoadIcon(IDI_GOTOSTART_DISABLE);
	m_hGotoEndDisableIcon =		AfxGetApp()->LoadIcon(IDI_GOTOEND_DISABLE);
	m_hFastForwardDisableIcon = AfxGetApp()->LoadIcon(IDI_FASTFORWARD_DISABLE);
	m_hFastBackwardDisableIcon= AfxGetApp()->LoadIcon(IDI_FASTBACKWARD_DISABLE);
	m_hGotoStartEnableIcon =	AfxGetApp()->LoadIcon(IDI_GOTOSTART_ENABLE);
	m_hGotoEndEnableIcon =		AfxGetApp()->LoadIcon(IDI_GOTOEND_ENABLE);
	m_hFastForwardEnableIcon =	AfxGetApp()->LoadIcon(IDI_FASTFORWARD_ENABLE);
	m_hFastBackwardEnableIcon = AfxGetApp()->LoadIcon(IDI_FASTBACKWARD_ENABLE);
	m_bInitialized=FALSE;
	m_bPicQuality=		FALSE;
	m_nPrePlayPos=		0;
	m_bFileRefCreated=	FALSE;
	m_nDisplayType=		DISPLAY_NORMAL;
}

void CPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlayerDlg)
	DDX_Control(pDX, IDC_SLIDERB, m_SliderB);
	DDX_Control(pDX, IDC_SLIDERS, m_SliderS);
	DDX_Control(pDX, IDC_SLIDERH, m_SliderH);
	DDX_Control(pDX, IDC_SLIDERC, m_SliderC);
	DDX_Control(pDX, IDC_SHOW, m_ShowFrame);
	DDX_Control(pDX, IDC_SOUND_SLIDER, m_SoundSlider);
	DDX_Control(pDX, IDC_PLAY_SLIDER, m_PlaySlider);
	DDX_Text(pDX, IDC_PLAYSTATETEXT, m_strPlayStateText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPlayerDlg, CDialog)
	//{{AFX_MSG_MAP(CPlayerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_GOTOSTART, OnGotoStart)
	ON_BN_CLICKED(IDC_SLOW, OnFastBackward)
	ON_BN_CLICKED(IDC_FAST, OnFastForward)
	ON_BN_CLICKED(IDC_GOTOEND, OnGotoEnd)
	ON_WM_DESTROY()
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_VIEW_FULLSCREEN, OnViewFullscreen)
	ON_WM_KEYDOWN()
	ON_WM_HSCROLL()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SOUND, OnSound)
	ON_BN_CLICKED(IDC_STEP, OnStep)
	ON_WM_SIZE()
	ON_WM_DROPFILES()
	ON_BN_CLICKED(IDC_CAPPIC, OnCappic)
	ON_WM_SIZING()
	ON_COMMAND(ID_REPEAT, OnRepeat)
	ON_COMMAND(ID_QUALITY, OnQuality)
	ON_COMMAND(ID_VIEW_ZOOM_100, OnViewZoom100)
	ON_COMMAND(ID_VIEW_ZOOM_200, OnViewZoom200)
	ON_COMMAND(ID_VIEW_ZOOM_50, OnViewZoom50)
	ON_WM_WINDOWPOSCHANGED()
	ON_COMMAND(ID_STREAM_TYPE, OnStreamType)
	ON_BN_CLICKED(IDC_STEPBACK, OnStepback)
	ON_WM_MOVE()
	ON_COMMAND(ID_INFO, OnInfo)
	ON_COMMAND(ID_SEEK, OnSeek)
	ON_COMMAND(ID_CUT_FILE, OnCutFile)
	ON_COMMAND(ID_THROW0, OnThrow0)
	ON_COMMAND(ID_THROW1, OnThrow1)
	ON_COMMAND(ID_THROW2, OnThrow2)
	ON_COMMAND(ID_DISNORMAL, OnDisnormal)
	ON_COMMAND(ID_DISQUARTER, OnDisquarter)
	ON_COMMAND(ID_SETDISPLAY, OnSetDisplay)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_TIMER1, OnTimer1)
	ON_COMMAND(ID_TIMER2, OnTimer2)
	ON_COMMAND(ID_RESET_BUF, OnResetBuf)
	ON_COMMAND(ID_CONVERT, OnConvertToAVI)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_FILE_END, PlayMessage)
	ON_MESSAGE(WM_ENC_CHANGE,EncChangeMessage)
	ON_MESSAGE(WM_SEEKOK, SeekOk)
	ON_MESSAGE(WM_DISPLAY_OK, DisplayOk)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerDlg message handlers

#define COLOR_DEFAULT 64 //brightness, contrast, saturation, hue default value(0~128);

BOOL CPlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_pMainMenu = GetMenu();
	if(m_pMainMenu == NULL)
	{
		TRACE("GetMenu is Error!");
		return FALSE;
	}
	m_nScreenWidth = GetSystemMetrics(SM_CXSCREEN);
	m_nScreenHeight = GetSystemMetrics(SM_CYSCREEN);
	// Init Play Slider
	m_dwPlaySliderMax = 200;
	m_PlaySlider.SetRangeMin(0);
	m_PlaySlider.SetRangeMax(m_dwPlaySliderMax);
	m_PlaySlider.SetPos(0);
	m_PlaySlider.SetLineSize(1);
	m_PlaySlider.SetPageSize(5);
	m_PlaySlider.EnableWindow(FALSE);
	
	//Init color slider
	m_SliderB.SetRange(0, 128);
	m_SliderB.SetPos(COLOR_DEFAULT);
	m_SliderC.SetRange(0, 128);
	m_SliderC.SetPos(COLOR_DEFAULT);
	m_SliderS.SetRange(0, 128);
	m_SliderS.SetPos(COLOR_DEFAULT);
	m_SliderH.SetRange(0, 128);
	m_SliderH.SetPos(COLOR_DEFAULT);

	// Init Sound Slider
#ifdef WAVE_ADJ
	m_SoundSlider.SetRangeMin(MIN_WAVE_COEF);
	m_SoundSlider.SetRangeMax(MAX_WAVE_COEF);
	m_SoundSlider.SetPos(0);
#else
	m_SoundSlider.SetRangeMin(0);
	m_SoundSlider.SetRangeMax(0xffff-1);
	m_SoundSlider.SetPos(0xffff>>1);
#endif

	m_SoundSlider.SetLineSize(1);
	m_SoundSlider.SetPageSize(5);
	m_SoundSlider.EnableWindow(FALSE);


	PlayM4_SetVolume(PORT,m_SoundSlider.GetPos());

	// init button;
	CButton *pButton;

	pButton = (CButton *)GetDlgItem(IDC_PLAY);
	pButton->SetIcon(m_hPlayDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_PAUSE);
	pButton->SetIcon(m_hPauseDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STOP);
	pButton->SetIcon(m_hStopDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOSTART);
	pButton->SetIcon(m_hGotoStartDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOEND);
	pButton->SetIcon(m_hGotoEndDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_FAST);
	pButton->SetIcon(m_hFastForwardDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_SLOW);
	pButton->SetIcon(m_hFastBackwardDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_SOUND);
	pButton->SetIcon(m_hSoundStopIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STEP);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STEPBACK);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_CAPPIC);
	pButton->EnableWindow(FALSE);

	InitWindowSize(WIDTH,HEIGHT_PAL);
	m_bStartDraw=			FALSE;
	m_StartPoint.x=			0;
	m_StartPoint.y=			0;
	m_nTotalFrames=			0;
	m_nMaxFileTime=			0;
	m_bSound=				FALSE;
	m_bOpen=				FALSE;
	m_bPlaying=				FALSE;
	m_bPaused=				FALSE;
	m_bFullScreen=			FALSE;
	m_bFastForwardPlay=		FALSE;
	m_bRepeatPlay=			FALSE;
	m_strPlayStateText=		"Ready";
	m_bPause=				FALSE;
	m_nTotalHour=			0;
	m_nTotalMinute=			0;
	m_nTotalSecond=			0;
	m_nTotalFrames=			0;
	m_bStreamType=			FALSE;

	m_pSeek=				new CSeek(this);
	m_pDisplayRegion=		new CDisplayRect(this);
	//set the capture picture call back function;
	PlayM4_SetDisplayCallBack(PORT,DisplayCBFun);
	//set the wave audio call back funtion;
	PlayM4_SetAudioCallBack(PORT,WaveCBFun, (long)this);
	m_BlackBmp.LoadBitmap(IDB_BLACK);
	m_OverlayBmp.LoadBitmap(IDB_OVERLAY);
//	m_Bmp.LoadBitmap(IDB_PRO);
	PlayM4_SetEncTypeChangeCallBack(PORT,funEncChange,(long)this);
#if (WINVER > 0x0400)
	//If do not support multi monitor,may not call!
	PlayM4_InitDDrawDevice();
	PlayM4_SetDDrawDevice(PORT,0);
#endif
	//Test adapter Capability;
	TestCapability(0);
	PlayM4_SetFileEndMsg(PORT,m_hWnd,WM_FILE_END);
	PlayM4_SetEncChangeMsg(PORT,m_hWnd,WM_ENC_CHANGE);
	if(m_strPlayFileName.Compare(""))
	{
		if(m_bStreamType)
			OpenStream();
		else
			OpenFile();
	}
	UpdateData(FALSE);
	m_bInitialized=TRUE;
	SortControl();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPlayerDlg::OnAppAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg AboutDlg;
	AboutDlg.DoModal();
	
}
void CPlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlayerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

	//	SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	PlayM4_RefreshPlay(PORT);
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlayerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPlayerDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
}



/////////////////////////////////////////////////////////////////////////////
//Function:Open file;
////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnFileOpen() 
{
	if(m_bOpen)
	{
		if(m_bStreamType)
			CloseStream();
		else
			CloseFile();
	}
	if(!BrowseFile(&m_strPlayFileName))
		return;
	if(m_bStreamType)
		OpenStream();
	else
		OpenFile();
	
	m_bPicQuality=TRUE;
	PlayM4_SetPicQuality(PORT,m_bPicQuality);
	m_pMainMenu->CheckMenuItem(ID_QUALITY,MF_CHECKED );
}
void CPlayerDlg::OpenFile()
{
	TRACE("Open fileNAME  IS:%s",m_strPlayFileName);
	PlayM4_SetFileRefCallBack(PORT,FileRefDone,(DWORD)this);
	PlayM4_SetVerifyCallBack(PORT, 0, 0xffffffff, VerifyFun, (DWORD) this);// verify the whole file;
	if(!PlayM4_OpenFile(PORT,m_strPlayFileName.GetBuffer(m_strPlayFileName.GetLength())))
	{
		m_strPlayFileName="";
		CString csError;
		csError.Format("Open file failed(%d)",PlayM4_GetLastError(PORT));
		MessageBox(csError);
		return ;
	}
	SetOpenState();
	m_nMaxFileTime=PlayM4_GetFileTime(PORT);
	if(!m_nMaxFileTime)
	{
		MessageBox("File seconds is zero");
		return;
	}
	m_nTotalHour=m_nMaxFileTime/3600;
	m_nTotalMinute=(m_nMaxFileTime%3600)/60;
	m_nTotalSecond=m_nMaxFileTime%60;
	m_nTotalFrames=PlayM4_GetFileTotalFrames(PORT);
	numFrames=m_nTotalFrames;
	//If you want to change the display buffer. Do hear!
	//PlayM4_SetDisplayBuf(PORT,25);
	Play();
	SetWindowText((LPCTSTR) m_strPlayFileName);
	
}

void CPlayerDlg::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_bOpen)
	{
		if(m_bStreamType)
			CloseStream();
		else
			CloseFile();
	}

	DWORD nFileNameSize=DragQueryFile(hDropInfo,0,NULL,0);
	char * sFileName=new char[nFileNameSize+1];
	DragQueryFile(hDropInfo,0,sFileName,nFileNameSize+1);
	m_strPlayFileName=sFileName;
	if(m_bStreamType)
		OpenStream();
	else
		OpenFile();

	delete []sFileName;
	CDialog::OnDropFiles(hDropInfo);
}
///////////////////////////////////////////////////////////////////////////////
//Funtion:Close file;
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnFileClose() 
{
	// TODO: Add your command handler code here
	if(m_bStreamType)
		CloseStream();
	else
		CloseFile();	
	m_bConvert=0;
	//if(yuvBuf!=NULL)
		//free(yuvBuf);
	
}

void CPlayerDlg::CloseFile()
{
	Stop();
	PlayM4_CloseFile(PORT);
	SetCloseState();
	m_bFileRefCreated=	FALSE;	
}

////////////////////////////////////////////////////////////////////////////////
//Funtion:Play or change the play speed to normal;
///////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnPlay() 
{
	// TODO: Add your control notification handler code here
	Play();
}

void CPlayerDlg::Play()
{
	m_nSpeed=0;
	OnThrow0();
//#ifdef _TEST_CALLBACK
	if(m_bConvert)	   
	   PlayM4_SetDecCallBack(PORT,DecCBFun);
    else
		m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, FALSE);
//#endif
	if(m_bPlaying)
	{
		PlayM4_Play(PORT,GetDlgItem(IDC_SHOW)->m_hWnd);
	}
	else
	{
		if(m_bStreamType)
		{
			::SetFilePointer(m_hStreamFile,m_nHeadSize,0,FILE_BEGIN);
			PlayM4_ResetSourceBuffer(PORT);
			SetEvent(m_hEventInput);
		}
		m_bPlaying = PlayM4_Play(PORT,GetDlgItem(IDC_SHOW)->m_hWnd);
		m_bSound=PlayM4_PlaySound(PORT);
		if(m_bPlaying)
			SetTimer(PLAY_TIMER,500,NULL);
		
	}
	if(m_bPlaying)

		SetPlayState();
	else
	{
		CString csError;
		csError.Format("Play the file faild.(%d)",PlayM4_GetLastError(PORT));
		AfxMessageBox(csError);
	}
	
}
//////////////////////////////////////////////////////////////////////////////
//Funtion:pause.
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnPause() 
{
	// TODO: Add your control notification handler code here
	if(m_bPlaying)
	{
		m_bPause=!m_bPause;
		Pause(m_bPause);
	}
}
void CPlayerDlg::Pause(BOOL bPause)
{
	if(m_bPaused == bPause)
		return;
	m_bPaused=bPause;
	PlayM4_Pause(PORT,bPause);
	TRACE("PAUSE %d\n",m_bPaused);
}
/////////////////////////////////////////////////////////////////////////////
//Function: Stop
/////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	
	if(m_bPlaying)
	{
		Stop();
	}
	if(m_bConvert)
	{
	   if(outFile!=NULL)
          closeWriffFiles();	
	   if(yuvBuf!=NULL)
	   {
	       free(yuvBuf);
		   yuvBuf=NULL;
	   }
	   m_bConvert=0;    

	   CSliderCtrl* pSlider;
	   pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERB);
	   pSlider->EnableWindow(TRUE);

	   pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERC);
	   pSlider->EnableWindow(TRUE);

       pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERS);
	   pSlider->EnableWindow(TRUE);

	   pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERH);
	   pSlider->EnableWindow(TRUE);

	   pSlider=(CSliderCtrl*)GetDlgItem(IDC_PLAY_SLIDER);
	   pSlider->EnableWindow(TRUE);
	}
}
void CPlayerDlg::Stop()
{
	CButton *pButton;
	if(!m_bPlaying)
		return;
	KillTimer(PLAY_TIMER);
	if(PlayM4_StopSound())
	{
		m_bSound=FALSE;
		pButton = (CButton *)GetDlgItem(IDC_SOUND);
		pButton->SetIcon(m_hSoundStopIcon);
	}
	//continue before stop.Add by lgl at 9-19;
	m_bPause=FALSE;
	
	//stop
	m_bPlaying = !PlayM4_Stop(PORT);
	if(!m_bPlaying)	
	{
		SetStopState();
		if(m_bStreamType)
			ResetEvent(m_hEventInput);
	}

	
}
///////////////////////////////////////////////////////////////////////////////
//Funtion:Locate to the file head.
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnGotoStart() 
{
	// TODO: Add your control notification handler code here
	if(m_bFileRefCreated)
		PlayM4_SetCurrentFrameNum(PORT,0);
	else
		PlayM4_SetPlayPos(PORT,0);
}
///////////////////////////////////////////////////////////////////////////////
//Funtion:Locate to the end.
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnGotoEnd() 
{
	// TODO: Add your control notification handler code here
	if(m_bFileRefCreated)
	{
		//Note: May create many WM_FILE_END message. The best way is to synchronize the option;
		
		int nEndFrame=m_nTotalFrames;
		while(!PlayM4_SetCurrentFrameNum(PORT,nEndFrame--))
		{
			//TRACE("FrameNum is :%d\n",nEndFrame);
			if(nEndFrame==0)
				break;
		}
	}
	else
		PlayM4_SetPlayPos(PORT,1);

}
//////////////////////////////////////////////////////////////////////////////
//Funtion: Fast
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnFastForward() 
{
	// TODO: Add your control notification handler code here
	//Throw B-Frame ,improve the performance;
	
	if(PlayM4_Fast(PORT))
	{
		m_nSpeed++;
		if(m_nSpeed>0)
			OnThrow2();
		SetFastForwardState();		
	}	
}
//////////////////////////////////////////////////////////////////////////////
//Funtion: Slow;
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnFastBackward() 
{
	// TODO: Add your control notification handler code here
	if(PlayM4_Slow(PORT))
	{
		m_nSpeed--;
		if(m_nSpeed<=0)
			OnThrow0();
		SetFastBackWardState();
	}
}
//////////////////////////////////////////////////////////////////////////////
//Function:Borwse the file to play.
//////////////////////////////////////////////////////////////////////////////
BOOL CPlayerDlg::BrowseFile(CString *strFileName)
{
	CFileDialog dlg(TRUE, 
					"mpg",
					NULL, 
					OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					"H264(*.mp4;*.264)|*.mp4;*.264|(*.*)|*.*||", this);
	if(dlg.DoModal() == IDCANCEL)
	{
		return FALSE;
	}
	*strFileName = dlg.GetPathName();
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////
//Funtion:change the video size to full-screen or normal.
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnViewFullscreen() 
{
	// TODO: Add your command handler code here
	CButton *pButton;
	m_bFullScreen = !m_bFullScreen;
	CStatic* pStatic;
	//HWND hAppBar;
	if(m_bFullScreen)
	{
		//hAppBar = FindWindowEx(0,0,"Shell_TrayWnd",""); 
		//::ShowWindow(hAppBar,SW_HIDE);
		//Save the pre info;
		GetWindowPlacement(&m_OldWndpl);
		//Remove WS_SIZEBOX windows style. or not the window can't be full-creen.
		ModifyStyle(WS_SIZEBOX,0,0);
		
		CRect WindowRect, ClientRect;
		RECT m_FullScreenRect;
		//ReDraw the window. Get the correct edge value.
		GetWindowRect(&WindowRect);
		WindowRect.left+=1;
		WindowRect.right+=1;
		MoveWindow(CRect(0,0,352,288),TRUE);
		
		GetWindowRect(&WindowRect);
		GetClientRect(&ClientRect);
		ClientToScreen(&ClientRect);
		
		//get the dest window rect.
		m_FullScreenRect.left = WindowRect.left - ClientRect.left;
		m_FullScreenRect.top = WindowRect.top - ClientRect.top;
		m_FullScreenRect.right = WindowRect.right - ClientRect.right + m_nScreenWidth;
		m_FullScreenRect.bottom = WindowRect.bottom - ClientRect.bottom + m_nScreenHeight;
		//Move the main window to the dest rect.
		WINDOWPLACEMENT wndpl;
		wndpl.length = sizeof(WINDOWPLACEMENT);
		wndpl.flags = 0;
		wndpl.showCmd = SW_SHOWNORMAL;
		wndpl.rcNormalPosition = m_FullScreenRect;
		SetWindowPlacement(&wndpl);
		//Move the view winow to full-screen.
		RECT rc;
		GetClientRect(&rc);
		GetDlgItem(IDC_SHOW)->MoveWindow(&rc,TRUE);
	
		//Remove WS_VISIBLE window style.
		pButton = (CButton *)GetDlgItem(IDC_PLAY);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);

		pButton = (CButton *)GetDlgItem(IDC_PAUSE);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);
		
		pButton = (CButton *)GetDlgItem(IDC_STOP);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);
		
		pButton = (CButton *)GetDlgItem(IDC_FAST);	
		pButton->ModifyStyle(WS_VISIBLE,0,0);
		
		pButton = (CButton *)GetDlgItem(IDC_GOTOEND);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);
	
		pButton = (CButton *)GetDlgItem(IDC_SLOW);	
		pButton->ModifyStyle(WS_VISIBLE,0,0);
	
		pButton = (CButton *)GetDlgItem(IDC_GOTOSTART);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);

		pButton = (CButton *)GetDlgItem(IDC_SOUND);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);

		pButton = (CButton *)GetDlgItem(IDC_STEP);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);

		pButton = (CButton *)GetDlgItem(IDC_STEPBACK);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);

		pButton = (CButton *)GetDlgItem(IDC_CAPPIC);		
		pButton->ModifyStyle(WS_VISIBLE,0,0);


		m_SoundSlider.ModifyStyle(WS_VISIBLE,0,0);
		m_PlaySlider.ModifyStyle(WS_VISIBLE,0,0);
		m_SliderB.ModifyStyle(WS_VISIBLE,0,0);
		m_SliderC.ModifyStyle(WS_VISIBLE,0,0);
		m_SliderS.ModifyStyle(WS_VISIBLE,0,0);
		m_SliderH.ModifyStyle(WS_VISIBLE,0,0);

		pStatic=(CStatic*)GetDlgItem(IDC_STATIC1);
		pStatic->ModifyStyle(WS_VISIBLE,0,0);
		pStatic=(CStatic*)GetDlgItem(IDC_STATIC2);
		pStatic->ModifyStyle(WS_VISIBLE,0,0);
		pStatic=(CStatic*)GetDlgItem(IDC_STATIC3);
		pStatic->ModifyStyle(WS_VISIBLE,0,0);
		pStatic=(CStatic*)GetDlgItem(IDC_STATIC4);
		pStatic->ModifyStyle(WS_VISIBLE,0,0);

		GetDlgItem(IDC_PLAYSTATETEXT)->ModifyStyle(WS_VISIBLE,0,0);

	}
	else
	{
		
		//hAppBar = FindWindowEx(0,0,"Shell_TrayWnd",""); 
		//BOOL bRet=::ShowWindow(hAppBar,SW_SHOW);
		//Visible the control.
		pButton = (CButton *)GetDlgItem(IDC_PLAY);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);
	
		pButton = (CButton *)GetDlgItem(IDC_PAUSE);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);

		pButton = (CButton *)GetDlgItem(IDC_STOP);	
		pButton->ModifyStyle(0,WS_VISIBLE,0);

		pButton = (CButton *)GetDlgItem(IDC_FAST);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);
			
		pButton = (CButton *)GetDlgItem(IDC_GOTOEND);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);
	
		pButton = (CButton *)GetDlgItem(IDC_SLOW);	
		pButton->ModifyStyle(0,WS_VISIBLE,0);
	
		pButton = (CButton *)GetDlgItem(IDC_GOTOSTART);	
		pButton->ModifyStyle(0,WS_VISIBLE,0);

		pButton = (CButton *)GetDlgItem(IDC_SOUND);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);

		pButton = (CButton *)GetDlgItem(IDC_STEP);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);

		pButton = (CButton *)GetDlgItem(IDC_STEPBACK);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);

		pButton = (CButton *)GetDlgItem(IDC_CAPPIC);		
		pButton->ModifyStyle(0,WS_VISIBLE,0);
		
		m_PlaySlider.ModifyStyle(0,WS_VISIBLE,0);
		m_SoundSlider.ModifyStyle(0,WS_VISIBLE,0);
		m_SliderB.ModifyStyle(0,WS_VISIBLE,0);
		m_SliderC.ModifyStyle(0,WS_VISIBLE,0);
		m_SliderS.ModifyStyle(0,WS_VISIBLE,0);
		m_SliderH.ModifyStyle(0,WS_VISIBLE,0);

		pStatic=(CStatic*)GetDlgItem(IDC_STATIC1);
		pStatic->ModifyStyle(0,WS_VISIBLE,0);
		pStatic=(CStatic*)GetDlgItem(IDC_STATIC2);
		pStatic->ModifyStyle(0,WS_VISIBLE,0);
		pStatic=(CStatic*)GetDlgItem(IDC_STATIC3);
		pStatic->ModifyStyle(0,WS_VISIBLE,0);
		pStatic=(CStatic*)GetDlgItem(IDC_STATIC4);
		pStatic->ModifyStyle(0,WS_VISIBLE,0);


		GetDlgItem(IDC_PLAYSTATETEXT)->ModifyStyle(0,WS_VISIBLE,0);
		
		//make the window can be resize.
		ModifyStyle(0,WS_SIZEBOX,0);
		//change the window pos to pre rect.
		SetWindowPlacement(&m_OldWndpl);

	}
	this->RedrawWindow();
	//2002-6-13 Refresh window.
	PlayM4_RefreshPlay(PORT);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	short sCtrl;
	UINT nMenuState;
	sCtrl = GetKeyState(VK_CONTROL);
	if(nChar == VK_F2) 
		OnViewFullscreen();

	if(sCtrl & 0xFF00)
	{
		switch(nChar)
		{
		case VK_C:
			nMenuState = m_pMainMenu->GetMenuState(ID_FILE_CLOSE, MF_BYCOMMAND);
			if(nMenuState != MF_GRAYED)		OnFileClose();
			break;
		case VK_O:
			nMenuState = m_pMainMenu->GetMenuState(ID_FILE_OPEN, MF_BYCOMMAND);
			if(nMenuState != MF_GRAYED)		OnFileOpen();
			break;
		
		case VK_S:
			nMenuState = m_pMainMenu->GetMenuState(IDC_STOP, MF_BYCOMMAND);
			if(nMenuState != MF_GRAYED)		OnFileClose();
			break;
		
		}
	}

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}
///////////////////////////////////////////////////////////////////////////
//Function: Voluem and progress.
///////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	DWORD nTime;
	int nPlayPos;
	int nBrightness, nContrast, nSaturation, nHue;
	switch(GetWindowLong(pScrollBar->m_hWnd, GWL_ID))
	{
	/////////////////////////////////////////////////////////////////
	//progress slider
	case IDC_PLAY_SLIDER:
		if(m_bStreamType)
			break;
		nPlayPos=m_PlaySlider.GetPos();
		if(abs(nPlayPos-m_nPrePlayPos)<3)
			break;
#ifdef _FILE_POS
		PlayM4_SetPlayPos(PORT,(float)nPlayPos/(float)m_dwPlaySliderMax);
#else
		nTime=nPlayPos*1000/m_dwPlaySliderMax*m_nMaxFileTime;
		TRACE("Set time ex \n");
		PlayM4_SetPlayedTimeEx(PORT,nTime);
		TRACE("set time ex ok!\n");
#endif
		DrawStatus();
		break;

	///////////////////////////////////////////////////////////////
	//sound slider;
	case IDC_SOUND_SLIDER:
#ifdef WAVE_ADJ
		PlayM4_AdjustWaveAudio(PORT, m_SoundSlider.GetPos());
#else
		PlayM4_SetVolume(PORT,m_SoundSlider.GetPos());
#endif
		break;

	////////////////////////////////////////////////////////////////
	//color slider
	case IDC_SLIDERB:
	case IDC_SLIDERC:
	case IDC_SLIDERS:
	case IDC_SLIDERH:
		nBrightness = m_SliderB.GetPos();
		nContrast = m_SliderC.GetPos();
		nSaturation = m_SliderS.GetPos();
		nHue = m_SliderH.GetPos();
		
		PlayM4_SetColor(PORT, 0, nBrightness, nContrast, nSaturation, nHue);
		//PlayM4_GetColor(PORT, 0, &nBrightness, &nContrast, &nSaturation, &nHue);
		//TRACE("Get color(B,C,S,V):%d, %d, %d, %d\n", nBrightness, nContrast, nSaturation, nHue);
		break;
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_bPlaying)
		OnViewFullscreen();
		
	CDialog::OnLButtonDblClk(nFlags, point);
}
/////////////////////////////////////////////////////////////////////////////
//Function: process the received WM_FILE_END message.
//Para:wParam channel No. lParam reserved
////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::PlayMessage(WPARAM wParam, LPARAM lParam)
{
	if(m_bFullScreen)
			OnViewFullscreen();
	//remove the same message.
	MSG msgVal;
	while(PeekMessage(&msgVal,m_hWnd,WM_FILE_END,WM_FILE_END,PM_REMOVE))
		;
			
	if(m_bRepeatPlay)
	{
		TRACE("/////////Process message %d\n",lParam);
		if(m_bFileRefCreated)
			PlayM4_SetCurrentFrameNum(PORT,0);
		else
			PlayM4_SetPlayPos(PORT,0);
	//	OnStop();
	//	OnPlay();
	}
	if(m_bConvert)
	{  
		OnStop();
		if(outFile!=NULL)
	      closeWriffFiles();
	   //MessageBox("Convertion complete!!",NULL,MB_ICONINFORMATION);	  	  
	}

}
void CPlayerDlg::EncChangeMessage(WPARAM wParam, LPARAM lParam)
{
	MSG msgVal;
	while(PeekMessage(&msgVal,m_hWnd,WM_ENC_CHANGE,WM_ENC_CHANGE,PM_REMOVE))
		;
	SetWindowSize();
	Sleep(1);
}
/////////////////////////////////////////////////////////////////////////////
//Funtion:change Interface 
/////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetStopState()
{
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);		
	pButton->SetIcon(m_hPlayEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_PAUSE);		
	pButton->SetIcon(m_hPauseDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STOP);		
	pButton->SetIcon(m_hStopDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_FAST);		
	pButton->SetIcon(m_hFastForwardDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_SLOW);		
	pButton->SetIcon(m_hFastBackwardDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOEND);	
	pButton->SetIcon(m_hGotoEndDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOSTART);	
	pButton->SetIcon(m_hGotoStartDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STEP);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STEPBACK);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_CAPPIC);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_SOUND);
	pButton->EnableWindow(FALSE);

	m_ShowFrame.SetBitmap(m_Bmp);

	m_pMainMenu->EnableMenuItem(IDC_STOP, TRUE);
	m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, TRUE);
    m_pMainMenu->EnableMenuItem(ID_FILE_OPEN, FALSE);
	m_pMainMenu->EnableMenuItem(ID_VIEW_FULLSCREEN, TRUE);
	m_pMainMenu->EnableMenuItem(IDC_FAST, TRUE);
	m_PlaySlider.SetPos(0);

	m_bPlaying = FALSE;
	m_bPaused = FALSE;
	m_bFastForwardPlay = FALSE;
	m_strPlayStateText = "Stop";
	UpdateData(FALSE);
	SortControl();
}
//////////////////////////////////////////////////////////////////////////////
//funtion:change interface
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetPlayState()
{
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);
	pButton->SetIcon(m_hPlayDisableIcon);
	pButton->EnableWindow(FALSE);
	
	pButton = (CButton *)GetDlgItem(IDC_PAUSE);
	pButton->SetIcon(m_hPauseEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_STOP);
	pButton->SetIcon(m_hStopEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_FAST);
	pButton->SetIcon(m_hFastForwardEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_SLOW);
	pButton->SetIcon(m_hFastBackwardEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOEND);
	pButton->SetIcon(m_hGotoEndEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOSTART);
	pButton->SetIcon(m_hGotoStartEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_STEP);
	pButton->EnableWindow(TRUE);

	if(m_bConvert)
        m_bFileRefCreated=FALSE;
	if(m_bFileRefCreated)
	{
		pButton = (CButton *)GetDlgItem(IDC_STEPBACK);
		pButton->EnableWindow(TRUE);
	}

	pButton = (CButton *)GetDlgItem(IDC_CAPPIC);
	pButton->EnableWindow(TRUE);


	pButton = (CButton *)GetDlgItem(IDC_SOUND);
	pButton->EnableWindow(TRUE);

	if(m_bSound)
	{
		pButton = (CButton *)GetDlgItem(IDC_SOUND);
		pButton->SetIcon(m_hSoundStartIcon);
		pButton->EnableWindow(TRUE);
	}

	GetDlgItem(IDC_SOUND_SLIDER)->EnableWindow(TRUE);
	
	if((HBITMAP)m_OverlayBmp!=m_ShowFrame.GetBitmap())
		m_ShowFrame.SetBitmap(m_OverlayBmp);

	m_pMainMenu->EnableMenuItem(IDC_STOP, FALSE);
	//m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, FALSE);
	m_pMainMenu->EnableMenuItem(ID_VIEW_FULLSCREEN, FALSE);
	m_pMainMenu->EnableMenuItem(IDC_FAST, FALSE);

	m_bFastForwardPlay = FALSE;
	m_PlaySlider.EnableWindow(TRUE);

	SortControl();
	
	UpdateData(FALSE);
	PlayM4_RefreshPlay(PORT);
}
//////////////////////////////////////////////////////////////////////////////
//Function: chane interface to pause.
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetPauseState(BOOL bPause)
{
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);
	if(bPause)
	{
		pButton->SetIcon(m_hPlayEnableIcon);
		pButton->EnableWindow(TRUE);
	}
	else
	{
		pButton->SetIcon(m_hPlayDisableIcon);
		pButton->EnableWindow(FALSE);
	}

	pButton = (CButton *)GetDlgItem(IDC_PAUSE);		
	if(bPause)
	{
		pButton->SetIcon(m_hPauseDisableIcon);
		pButton->EnableWindow(FALSE);
	}
	else
	{
		pButton->SetIcon(m_hPauseEnableIcon);
		pButton->EnableWindow(TRUE);
	}

	m_bPaused = bPause;
	UpdateData(FALSE);
}
//////////////////////////////////////////////////////////////////////////////
//Function:change interface to fast;
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetFastForwardState()
{
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);
	pButton->SetIcon(m_hPlayEnableIcon);
	pButton->EnableWindow(TRUE);
	
	pButton = (CButton *)GetDlgItem(IDC_PAUSE);
	pButton->SetIcon(m_hPauseEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_STOP);
	pButton->SetIcon(m_hStopEnableIcon);
	pButton->EnableWindow(TRUE);

	//m_pMainMenu->EnableMenuItem(ID_FILE_PLAY, FALSE);
	//m_pMainMenu->EnableMenuItem(IDC_STOP, FALSE);
	m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, FALSE);
	m_pMainMenu->EnableMenuItem(ID_VIEW_FULLSCREEN, FALSE);

	m_bFastForwardPlay = TRUE;
	UpdateData(FALSE);
}
//////////////////////////////////////////////////////////////////////////////
//Funtion:sort the controls
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SortControl()
{
	TRACE("init SORT\n");
	if(!m_bInitialized)
		return ;
	CRect rcWin,rcClient;
	
	GetWindowRect(&rcWin);
	GetClientRect(&rcClient);
	DWORD x=LEFT_EDGE+10,y=rcClient.bottom-STATE_HEIGHT;
	
	//STATE 
	GetDlgItem(IDC_PLAYSTATETEXT)->MoveWindow(0,y,rcClient.Width()+1,STATE_HEIGHT,TRUE);
	y-=BUTTON_SIZE+STATE_UP;
////////////////////////////////////////////////////////
	GetDlgItem(IDC_SLIDERB)->MoveWindow(x,y,70,20,TRUE);
	GetDlgItem(IDC_STATIC1)->MoveWindow(LEFT_EDGE,y,10,20,TRUE);

	x+=90;
	GetDlgItem(IDC_SLIDERC)->MoveWindow(x,y,70,20,TRUE);
	GetDlgItem(IDC_STATIC2)->MoveWindow(x-15,y,10,20,TRUE);

	x+=90;
	GetDlgItem(IDC_SLIDERS)->MoveWindow(x,y,70,20,TRUE);
	GetDlgItem(IDC_STATIC3)->MoveWindow(x-15,y,10,20,TRUE);

	x+=90;
	GetDlgItem(IDC_SLIDERH)->MoveWindow(x,y,70,20,TRUE);
	GetDlgItem(IDC_STATIC4)->MoveWindow(x-15,y,10,20,TRUE);
//////////////////////////////////////////////////////////
	x=LEFT_EDGE;
	y-=30;
	//BUTTON
	GetDlgItem(IDC_PLAY)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;
	GetDlgItem(IDC_PAUSE)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;
	GetDlgItem(IDC_STOP)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;

	x+=INTERVAL;
	GetDlgItem(IDC_INTER1)->MoveWindow(x,y,INTERVAL_SIZE,BUTTON_SIZE,TRUE);
	x+=INTERVAL_SIZE;
	x+=INTERVAL;

	GetDlgItem(IDC_GOTOSTART)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;
	GetDlgItem(IDC_SLOW)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;
	GetDlgItem(IDC_FAST)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;
	GetDlgItem(IDC_GOTOEND)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;

	x+=INTERVAL;
	GetDlgItem(IDC_INTER2)->MoveWindow(x,y,INTERVAL_SIZE,BUTTON_SIZE,TRUE);
	x+=INTERVAL_SIZE;
	x+=INTERVAL;

	GetDlgItem(IDC_STEPBACK)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;

	GetDlgItem(IDC_STEP)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;

	
	GetDlgItem(IDC_CAPPIC)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);
	x+=BUTTON_SIZE;

	m_nPlayButtonsWidth=x;
	
	//SOUND
	x=rcClient.right-SOUND_SLIDER_WIDTH;
	GetDlgItem(IDC_SOUND_SLIDER)->MoveWindow(x,y+BUTTON_SIZE-SOUND_SLIDER_HEIGHT,SOUND_SLIDER_WIDTH,SOUND_SLIDER_HEIGHT,TRUE);
	x-=BUTTON_SIZE;

	GetDlgItem(IDC_SOUND)->MoveWindow(x,y,BUTTON_SIZE,BUTTON_SIZE,TRUE);

	y-=BUTTON_SIZE+BUTTON_UP;
	//PLAY SLIDER
	x=0;
	GetDlgItem(IDC_PLAY_SLIDER)->MoveWindow(x,y,rcClient.Width(),PLAY_SLIDER_HEIGHT,TRUE);
	y-=PLAY_SLIDER_UP;
	//pic show
	GetDlgItem(IDC_SHOW)->MoveWindow(0,0,rcClient.Width(),y,TRUE);
	GetDlgItem(IDC_SHOW)->GetClientRect(&rcWin);
//	this->RedrawWindow();
	PlayM4_RefreshPlay(PORT);
	TRACE("exit SORT\n");
}
////////////////////////////////////////////////////////////////////////////////
//Funtion:Change interface to slow
////////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetFastBackWardState()
{
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);		
	pButton->SetIcon(m_hPlayEnableIcon);
	pButton->EnableWindow(TRUE);
	
	pButton = (CButton *)GetDlgItem(IDC_PAUSE);		
	pButton->SetIcon(m_hPauseEnableIcon);
	pButton->EnableWindow(TRUE);

	pButton = (CButton *)GetDlgItem(IDC_STOP);		
	pButton->SetIcon(m_hStopEnableIcon);
	pButton->EnableWindow(TRUE);

	//m_pMainMenu->EnableMenuItem(ID_FILE_PLAY, FALSE);
	//m_pMainMenu->EnableMenuItem(IDC_STOP, FALSE);
	m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, FALSE);
	m_pMainMenu->EnableMenuItem(ID_VIEW_FULLSCREEN, FALSE);

	UpdateData(FALSE);
}
/////////////////////////////////////////////////////////////////////
//Timer funtion
/////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==PLAY_TIMER)
	{
		DrawStatus();
	}
	CDialog::OnTimer(nIDEvent);
}
//////////////////////////////////////////////////////////////////////////
//Funtion: Draw the status .
//////////////////////////////////////////////////////////////////////////
void CPlayerDlg::DrawStatus()
{
		DWORD nCurrentTime=PlayM4_GetPlayedTime(PORT);
		//TRACE("Get time is:%d\n",nCurrentTime);			
		DWORD nHour=(nCurrentTime/3600)%24;
		DWORD nMinute=(nCurrentTime%3600)/60;
		DWORD nSecond=nCurrentTime%60;
		int nPos=0;
		if(m_bStreamType)
		{
			DWORD nFilePos=SetFilePointer(m_hStreamFile,0,0,FILE_CURRENT);
			nPos=nFilePos*m_dwPlaySliderMax/m_nMaxFileSize;
		}
		else
		{
#ifdef _FILE_POS
		float fPos=PlayM4_GetPlayPos(PORT);
		nPos=int(fPos*m_dwPlaySliderMax);
		
#else
		nPos=nCurrentTime*m_dwPlaySliderMax/m_nMaxFileTime;
			
#endif
		}

		DWORD nCurrentFrame=PlayM4_GetCurrentFrameNum(PORT);
		m_strPlayStateText.Format("%d/%d  %02d:%02d:%02d/%02d:%02d:%02d",nCurrentFrame,m_nTotalFrames,nHour,nMinute,nSecond,m_nTotalHour,m_nTotalMinute,m_nTotalSecond);
		if(m_bConvert)
			m_strPlayStateText.Format("Converting        %d/%d  %02d:%02d:%02d/%02d:%02d:%02d",nCurrentFrame,m_nTotalFrames,nHour,nMinute,nSecond,m_nTotalHour,m_nTotalMinute,m_nTotalSecond);     
		GetDlgItem(IDC_PLAYSTATETEXT)->SetWindowText(m_strPlayStateText);

		if(m_nPrePlayPos==nPos)
			return;
		//adjust the slider.
		INT nAdjust=(m_nPrePlayPos<nPos)?1:0;
		m_PlaySlider.SetPos(nPos+nAdjust);
		m_nPrePlayPos=nPos;
		
		//test
		//TRACE("Current frame rate:%d\n",PlayM4_GetCurrentFrameRate(PORT));
		//TRACE("Current time use ms:%d\n",PlayM4_GetPlayedTimeEx(PORT));
	
}
/////////////////////////////////////////////////////////////////////
//Funtion: play sound
////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnSound() 
{
	// TODO: Add your control notification handler code here
	CButton *pButton;
	if(m_bSound)
	{
		if(PlayM4_StopSound())
		{
			m_bSound=FALSE;
			pButton = (CButton *)GetDlgItem(IDC_SOUND);
			pButton->SetIcon(m_hSoundStopIcon);
			
		}
	}
	else
	{
		if(PlayM4_PlaySound(PORT))
		{
			pButton = (CButton *)GetDlgItem(IDC_SOUND);
			pButton->SetIcon(m_hSoundStartIcon);
			m_bSound=TRUE;
		}
	}
}
//////////////////////////////////////////////////////////////
//Funtion:Play step by step.
//////////////////////////////////////////////////////////////
void CPlayerDlg::OnStep() 
{
	// TODO: Add your control notification handler code here
	//you can do it like the followed too.
	//DWORD nCurrentFrame=PlayM4_GetCurrentFrameNum(PORT);
	//PlayM4_SetCurrentFrameNum(PORT,nCurrentFrame+1);
	PlayM4_OneByOne(PORT);
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);
	pButton->SetIcon(m_hPlayEnableIcon);
	pButton->EnableWindow(TRUE);
}
///////////////////////////////////////////////////////////////
//Funtion: Init window size.
////////////////////////////////////////////////////////////////
void CPlayerDlg::InitWindowSize(DWORD cx,DWORD cy)
{
	TRACE("init window\n");
	CRect rcWin,rcClient;
	GetWindowRect(&rcWin);
	GetClientRect(&rcClient);
	m_nDlgEdge=(rcWin.Width()-rcClient.Width())>>1;
	ClientToScreen(&rcClient);
	m_nDlgTopSize=rcClient.top-rcWin.top;
	DWORD nWindowHeight=cy+PANNEL_HEIGHT+m_nDlgTopSize+m_nDlgEdge;
	DWORD nWindowWidth = cx+(m_nDlgEdge<<1);
	MoveWindow(
		(m_nScreenWidth-nWindowWidth)/2,
		(m_nScreenHeight-nWindowHeight)/2,
		nWindowWidth,
		nWindowHeight,
		TRUE);
	
	TRACE("init window!!!!\n");
	SortControl();
	TRACE("exit window!\n");
	//add by lgl; at 2003-6-18;
	//for the small picture size.The menu will be high. 
	GetWindowRect(&rcWin);
	GetClientRect(&rcClient);
	m_nDlgEdge=(rcWin.Width()-rcClient.Width())>>1;
	ClientToScreen(&rcClient);
	DWORD nTopSize=rcClient.top-rcWin.top;
	if(nTopSize!=m_nDlgTopSize)
	{
		TRACE("re init window!!!!!!\n");
		m_nDlgTopSize=nTopSize;
		nWindowHeight=cy+PANNEL_HEIGHT+m_nDlgTopSize+m_nDlgEdge;
		nWindowWidth = cx+(m_nDlgEdge<<1);
		MoveWindow(
			(m_nScreenWidth-nWindowWidth)/2,
			(m_nScreenHeight-nWindowHeight)/2,
			nWindowWidth,
			nWindowHeight,
			TRUE);
		SortControl();
	}
}
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
void CPlayerDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
	SortControl();
	
}
//////////////////////////////////////////////////////////////////
//Function:The call back funtion for capture image!
/////////////////////////////////////////////////////////////////
void CALLBACK DisplayCBFun(long nPort,\
						   char * pBuf,long nSize,\
						   long nWidth,long nHeight,\
						   long nStamp,long nType,long nReceaved)
{
	if(!g_bCapPic)
		return;
	CString csFile;
	csFile.Format("capture%02d.bmp",pic);
	/*	switch(nType)
	{
	case T_UYVY:
	csFile="uyvy.bmp";
	break;
	case T_YV12:
	csFile="yv12.bmp";
	break;
	case T_RGB32:
	csFile="rgb.bmp";
	break;
	default: 
	return ;
}*/
	//Note:this funtion is slow,so if you want to save as a .bmp file,don't call! 
	if(!PLayM4_ConvertToBmpFile(pBuf,nSize,nWidth,nHeight,nType,csFile.GetBuffer(csFile.GetLength())))
	{
		CString csErr;
		csErr.Format("Convert to bmp faild(%d).",PlayM4_GetLastError(nPort));
		AfxMessageBox(csErr);
	}
	pic++;
	g_bCapPic=FALSE;
	
}
////////////////////////////////////
//Function: Capture;
///////////////////////////////////
void CPlayerDlg::OnCappic() 
{
	// TODO: Add your control notification handler code here
	g_bCapPic=TRUE;
}
void CALLBACK funEncChange(long nPort,long nUser)
{
//	return;
	CPlayerDlg* pOwner=(CPlayerDlg*)nUser;
	pOwner->SetWindowSize();
	
}
void CPlayerDlg::SetWindowSize()
{
//	TRACE("init window size!\n");
//	PlayM4_GetPictureSize(PORT,&m_nWidth,&m_nHeight);
//	TRACE("get window size ok\n");
	CRect rcWin,rcClient;
	GetWindowRect(&rcWin);
	GetClientRect(&rcClient);
	m_nDlgEdge=(rcWin.Width()-rcClient.Width())>>1;
	ClientToScreen(&rcClient);
	m_nDlgTopSize=rcClient.top-rcWin.top;
	TRACE("init window size!\n");
	PlayM4_GetPictureSize(PORT,&m_nWidth,&m_nHeight);
	TRACE("get window size ok\n");
	DWORD nWindowHeight=m_nHeight+PANNEL_HEIGHT+m_nDlgTopSize+m_nDlgEdge;
	DWORD nWindowWidth = m_nWidth+(m_nDlgEdge<<1);
	MoveWindow(
		(m_nScreenWidth-nWindowWidth)/2,
		(m_nScreenHeight-nWindowHeight)/2,
		nWindowWidth,
		nWindowHeight,
		TRUE);
	TRACE("exit window size\n");

}

/////////////////////////////////////////////////////////////////////////////////
//Function: The dec call back funtion.
////////////////////////////////////////////////////////////////////////////////
void CALLBACK DecCBFun(long nPort,char * pBuf,long nSize,
					   FRAME_INFO * pFrameInfo, 
					   long nReserved1,long nReserved2)
{
	TRACE("nPort=%d,TYPE=%d;Width=%d;Height=%d\n",nPort,pFrameInfo->nType,pFrameInfo->nWidth,pFrameInfo->nHeight);

	PlayM4_GetPictureSize(0,&frameWidth,&frameHeight);
	if(!m_bFirst)
	{
	   if ((yuvBuf = (char *)malloc( frameWidth*frameHeight*3/2 )) == NULL )
	   {
		  MessageBox( NULL,"Error: can't allocate YUV buffer\n",NULL,MB_OK );		    
	   }
	   m_bFirst=true;
	   if ( (outFile = riffCreate( LPCTSTR(szFileName) )) == NULL )
	   {
		MessageBox(NULL,"Error: can't open output file \n",NULL,MB_OK );
		SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_FILE_END,PORT,0);
		return;
	   }
	}
	
	if ((pFrameInfo->nWidth!=0)&&(pFrameInfo->nHeight!=0))
	{
	   memcpy(yuvBuf,pBuf,nSize);

	   frameWidth=pFrameInfo->nWidth;
	   frameHeight=pFrameInfo->nHeight;
	   Y_PLANE_SIZE = (frameWidth)*(frameHeight);

	   //U4_PLANE_SIZE = (frameWidth/4)*(frameHeight/4);
	   //V4_PLANE_SIZE = (frameWidth/4)*(frameHeight/4);

	   U2_PLANE_SIZE = (frameWidth/2)*(frameHeight/2);
	   V2_PLANE_SIZE = (frameWidth/2)*(frameHeight/2);

	   inputFrameSize  = Y_PLANE_SIZE + U2_PLANE_SIZE + V2_PLANE_SIZE;
	   outputFrameSize = Y_PLANE_SIZE + V2_PLANE_SIZE + U2_PLANE_SIZE;
       fps = pFrameInfo->nFrameRate;		

	   maxFrameSize = outputFrameSize;

       if(!m_bFirstWrite)
	   {
		 writeHeaders();
		 m_bFirstWrite=true;
	   }

       addFileToAVI(frameNum);
	   frameNum++;
	   if(frameNum>=MAX_FRAMES)
	   {
          SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_FILE_END,PORT,0);		   
	   }	
	}
	Sleep(1);
}
//////////////////////////////////////////////////////////////////////////////////
//Funtion: test the capability of your system.
/////////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::TestCapability(DWORD nDeviceNum)
{
	CString csCap="";
#if (WINVER > 0x0400)
	int nFlag=PlayM4_GetCapsEx(nDeviceNum);
#else
	int nFlag=PlayM4_GetCaps();
#endif

	if(!(nFlag&SUPPORT_SSE))
		csCap+="Don't support SSE instruction set;\r\n";
	if(!(nFlag&SUPPORT_DDRAW))
		csCap+="Create DirectDraw faild;\r\n";
	if(!(nFlag&SUPPORT_BLT))
		csCap+="Don't support BLT;\r\n";
	if(!(nFlag&SUPPORT_BLTFOURCC))
		csCap+="Don't support color-space conversions;\r\n";
	if(!(nFlag&SUPPORT_BLTSHRINKX))
		csCap+="Don't support arbitrary shrinking of a surface along the x-axis\r\n";
	if(!(nFlag&SUPPORT_BLTSHRINKY))
		csCap+="Don't supports arbitrary shrinking of a surface along the y-axis (vertically);\r\n";
	if(!(nFlag&SUPPORT_BLTSTRETCHX))
		csCap+="Don't supports arbitrary stretching of a surface along the x-axis;\r\n";
	if(!(nFlag&SUPPORT_BLTSTRETCHY))
		csCap+="Don't supports arbitrary stretching of a surface along the y-axis;\r\n";
	
	if(csCap.GetLength()>0)
	{
		csCap+="If your video adapter chip is made by nVidia,please update the new driver!\r\n";
		MessageBox(csCap,"Warning",MB_OK);
	}
}
//////////////////////////////////////////////////////////////////////
//Function: Limit the window size.
//////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnSizing(UINT fwSide, LPRECT pRect) 
{
	
	if((pRect->right-pRect->left)<100)
		pRect->right=pRect->left+100;
	if((pRect->bottom-pRect->top)<150)
		pRect->bottom=pRect->top+150;
	CDialog::OnSizing(fwSide, pRect);
	
	// TODO: Add your message handler code here
	
}
/////////////////////////////////////////////////////////////////////
//Funtion: Rewind
/////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnRepeat() 
{
	// TODO: Add your command handler code here
	if(m_bRepeatPlay)
	{
		m_pMainMenu->CheckMenuItem(ID_REPEAT,MF_UNCHECKED );
		m_bRepeatPlay=FALSE;
	}
	else
	{
		m_pMainMenu->CheckMenuItem(ID_REPEAT,MF_CHECKED );
		m_bRepeatPlay=TRUE;
	}
}

//////////////////////////////////////////////////////////////////////
//Function: Close.
//////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	PlayM4_Stop(PORT);
	PlayM4_CloseFile(PORT);
	PlayM4_RealeseDDraw();

#if (WINVER > 0x0400)
	PlayM4_ReleaseDDrawDevice();
#endif
	m_pSeek->DestroyWindow();
	delete m_pSeek;
	m_pDisplayRegion->DestroyWindow();
	delete m_pDisplayRegion;
	if(yuvBuf!=NULL)
	{
		free(yuvBuf);
		yuvBuf=NULL;
	}
	if(outFile) free(outFile);
	CDialog::OnClose();
}
///////////////////////////////////////////////////////////////////////
//Function: Set imagequality.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnQuality() 
{
	// TODO: Add your command handler code here
	if(m_bPicQuality)
	{
		m_pMainMenu->CheckMenuItem(ID_QUALITY,MF_UNCHECKED );
		m_bPicQuality=FALSE;
		
	}
	else
	{
		m_pMainMenu->CheckMenuItem(ID_QUALITY,MF_CHECKED );
		m_bPicQuality=TRUE;
	}
	PlayM4_SetPicQuality(PORT,m_bPicQuality);
}
///////////////////////////////////////////////////////////////////////
//Function:change the image quality by windows size.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnWindowPosChanged(WINDOWPOS FAR* lpwndpos) 
{
	CDialog::OnWindowPosChanged(lpwndpos);
	
	// TODO: Add your message handler code here

	//delete by lgl at 2003-6-18, don't change qulity.Suggest high quality! 
/*	CRect rcPlay;
	GetDlgItem(IDC_SHOW)->GetClientRect(rcPlay);
	if(rcPlay.Width()>352||rcPlay.Height()>288)
	{
		//TRACE("RECT BIG\n");
		if(!m_bPicQuality)
		{
			m_bPicQuality=TRUE;
			PlayM4_SetPicQuality(PORT,m_bPicQuality);
			m_pMainMenu->CheckMenuItem(ID_QUALITY,MF_CHECKED );
		}
	}
	else
	{
		//TRACE("RECT LITTLE\n");
		if(m_bPicQuality)
		{
			m_bPicQuality=FALSE;
			PlayM4_SetPicQuality(PORT,m_bPicQuality);
			m_pMainMenu->CheckMenuItem(ID_QUALITY,MF_UNCHECKED );
		}
	}
*/
}

///////////////////////////////////////////////////////////////////////
//Function:normal video size;
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnViewZoom100() 
{

	InitWindowSize(m_nWidth,m_nHeight);
}
///////////////////////////////////////////////////////////////////////
//Funtion: Double video size.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnViewZoom200() 
{
	// TODO: Add your command handler code here
	InitWindowSize(m_nWidth<<1,m_nHeight<<1);
}
///////////////////////////////////////////////////////////////////////
//half video size.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnViewZoom50() 
{
	// TODO: Add your command handler code here
	InitWindowSize(m_nWidth>>1,m_nHeight>>1);
}
///////////////////////////////////////////////////////////////////////
//Funtion: Open the file by stream type.
////////////////////////////////////////////////////////////////////////
BOOL CPlayerDlg::OpenStream()
{
	m_nTotalHour=			0;
	m_nTotalMinute=			0;
	m_nTotalSecond=			0;
	m_nTotalFrames=			0;
	m_bFileEnd=				FALSE;
	

	m_hStreamFile=CreateFile(m_strPlayFileName,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);
	if(m_hStreamFile==INVALID_HANDLE_VALUE)
	{
		MessageBox("Open file failed");
		return FALSE;
	}
	m_nMaxFileSize=::GetFileSize(m_hStreamFile,NULL);
	PlayM4_SetSourceBufCallBack(PORT,10000,SourceBufFun,(DWORD)this,NULL);
	PlayM4_SetStreamOpenMode(PORT,STREAME_FILE);
	m_nHeadSize=PlayM4_GetFileHeadLength();
	PBYTE pBuf;
	char csError[50];
	
	DWORD dw;
	m_hThread=NULL;
	m_hEventInput=NULL;
	m_hEventKill=NULL;
	__try
	{
		m_hThread=		CreateThread(NULL,0, LPTHREAD_START_ROUTINE (InputStreamThread),this,0,&dw);
		m_hEventInput=	CreateEvent(NULL,TRUE,FALSE,NULL);
		m_hEventKill=	CreateEvent(NULL,FALSE,FALSE,NULL);
		if(!(m_hThread&&m_hEventInput&&m_hEventKill))
		{
			MessageBox("Create thread failed");
			return FALSE;
		}
		pBuf=new BYTE[m_nHeadSize];
		if(!pBuf)
		{
			MessageBox("Alloc memory failed");
			return FALSE;
		}
		DWORD nRealRead;
		ReadFile(m_hStreamFile,pBuf,m_nHeadSize,&nRealRead,NULL);
		if(nRealRead!=m_nHeadSize)
		{
			MessageBox("File is too small");
			return FALSE;
		}
		if(!PlayM4_OpenStream(PORT,pBuf,m_nHeadSize,200000))
		{
			
			
			sprintf(csError,"Open stream failed(%d)",PlayM4_GetLastError(PORT));
			MessageBox(csError);
			return FALSE;
		}
	}
	__finally
	{
		if(pBuf)
		{
			delete []pBuf;
			pBuf=NULL;
		}

		if(AbnormalTermination())
		{
			CloseStream();
		}
	}
	SetOpenState();
	Play();
	return TRUE;
}
///////////////////////////////////////////////////////////////////////
//Function:Close the stream.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::CloseStream()
{
	Stop();
	PlayM4_CloseStream(PORT);
	if(m_hStreamFile)
	{
		CloseHandle(m_hStreamFile);
		m_hStreamFile=NULL;
	}
	
	if(m_hThread)
	{
		SetEvent(m_hEventKill);
		DWORD dwStatus;
		for(int i=0;i<5;i++)
		{
			if(!::GetExitCodeThread(m_hThread, &dwStatus)||i==4)
				{
					TerminateThread(m_hThread,0);
					TRACE("GetExitCode option error!-decodethread\n");
				}
				else
				{
					if(dwStatus==STILL_ACTIVE)
					{
						SetEvent(m_hEventKill);
						Sleep(2);
					}
					else
						break;
				}
		}
		CloseHandle(m_hThread);
		m_hThread=NULL;
	}
	if(m_hEventInput)
	{
		CloseHandle(m_hEventInput);
		m_hEventInput=NULL;
	}
	if(m_hEventKill)
	{
		CloseHandle(m_hEventKill);
		m_hEventKill=NULL;
	}
	SetCloseState();
	
}
///////////////////////////////////////////////////////////////////////
//Funtion:The source buffer call back funtion.
////////////////////////////////////////////////////////////////////////
void CALLBACK SourceBufFun(long nPort,DWORD nBufSize,DWORD dwUser,void*pContext)
{
	
	CPlayerDlg* pOwner=(CPlayerDlg*)dwUser;
	//do after play!
	if(!pOwner->m_bPlaying)
		return ;
	PlayM4_ResetSourceBufFlag(nPort);
	if(pOwner->m_bFileEnd)
	{
		
		PostMessage(pOwner->m_hWnd,WM_FILE_END,PORT,0);
		pOwner->m_bFileEnd=FALSE;
	}
	else
		SetEvent(pOwner->m_hEventInput);
}
///////////////////////////////////////////////////////////////////////
//Function: thread.
////////////////////////////////////////////////////////////////////////
#define BUF_SIZE 4096
DWORD WINAPI InputStreamThread( LPVOID lpParameter)
{
	CPlayerDlg* pOwner=(CPlayerDlg*)lpParameter;
	HANDLE hMulEvents[2];
	hMulEvents[0]=pOwner->m_hEventKill;
	hMulEvents[1]=pOwner->m_hEventInput;
	BYTE pBuf[BUF_SIZE];
	DWORD nRealRead;
	BOOL bBufFull=FALSE;
	while(WAIT_OBJECT_0!=WaitForMultipleObjects(2,hMulEvents,FALSE,INFINITE))
	{
		if(!bBufFull)
		{
			if(!(ReadFile(pOwner->m_hStreamFile,pBuf,BUF_SIZE,&nRealRead,NULL)&&nRealRead==BUF_SIZE))
			{
				//File end;
				pOwner->m_bFileEnd=TRUE;
				bBufFull=FALSE;
				ResetEvent(pOwner->m_hEventInput);
			}
		}
		if(!PlayM4_InputData(PORT,pBuf,BUF_SIZE))
		{
			bBufFull=TRUE;
			ResetEvent(pOwner->m_hEventInput);
		}
		else
			bBufFull=FALSE;
	}
	return 1;
}
///////////////////////////////////////////////////////////////////////
//Function: Change interface to open.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetOpenState()
{
	m_bOpen=TRUE;
	
	PlayM4_GetPictureSize(PORT,&m_nWidth,&m_nHeight);
	//HCIF
/*	if(m_nWidth==WIDTH*2&&m_nHeight<=HEIGHT_PAL)
		m_nHeight*=2;
*/
	InitWindowSize(m_nWidth,m_nHeight);
	CMenu *pSubMenue=m_pMainMenu->GetSubMenu(1);
	pSubMenue->EnableMenuItem(1,MF_ENABLED |MF_BYPOSITION);

	//try overlay mode!
	PlayM4_SetOverlayMode(PORT,TRUE,RGB(255,0,255));
	m_pMainMenu->EnableMenuItem(ID_STREAM_TYPE,MF_GRAYED|MF_DISABLED);

	//Disalbe TIMER SELECT
	m_pMainMenu->EnableMenuItem(ID_TIMER2,MF_GRAYED|MF_DISABLED);
	m_pMainMenu->EnableMenuItem(ID_TIMER1,MF_GRAYED|MF_DISABLED);
}
///////////////////////////////////////////////////////////////////////
//Funtion: change interface to close.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SetCloseState()
{
	if(!m_bPlaying)
	{
		m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, TRUE);
	}
	CMenu *pSubMenue=m_pMainMenu->GetSubMenu(1);
	pSubMenue->EnableMenuItem(1,MF_DISABLED|MF_GRAYED|MF_BYPOSITION);
	m_pMainMenu->EnableMenuItem(ID_STREAM_TYPE,MF_ENABLED);
	m_pMainMenu->EnableMenuItem(ID_CUT_FILE,MF_GRAYED);
	m_pMainMenu->EnableMenuItem(ID_SEEK,MF_GRAYED);
	m_strPlayFileName="";
	m_bOpen=FALSE;
	// Add 2004-4-26;
	m_SliderB.SetPos(COLOR_DEFAULT);
	m_SliderC.SetPos(COLOR_DEFAULT);
	m_SliderS.SetPos(COLOR_DEFAULT);
	m_SliderH.SetPos(COLOR_DEFAULT);
#ifdef WAVE_ADJ
	m_SoundSlider.SetPos(0);
#else
	m_SoundSlider.SetPos(0xffff>>1);
#endif

	GetDlgItem(IDC_PLAY)->EnableWindow(FALSE);
}
///////////////////////////////////////////////////////////////////////
//Funcion: select the open mode,stream or file.
////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnStreamType() 
{
	// TODO: Add your command handler code here
	if(m_bStreamType)
	{
		m_pMainMenu->CheckMenuItem(ID_STREAM_TYPE,MF_UNCHECKED );
		m_bStreamType=FALSE;
	}
	else
	{
		m_pMainMenu->CheckMenuItem(ID_STREAM_TYPE,MF_CHECKED );
		m_bStreamType=TRUE;
	}
}
///////////////////////////////////////////////////////////////////////
//Function:Step back;
//////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnStepback() 
{
	// TODO: Add your control notification handler code here
    //you can do as the followed.
	//DWORD nCurrentFrame=PlayM4_GetCurrentFrameNum(PORT);
	//PlayM4_SetCurrentFrameNum(PORT,nCurrentFrame-1);
	PlayM4_OneByOneBack(PORT);
	CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);
	pButton->SetIcon(m_hPlayEnableIcon);
	pButton->EnableWindow(TRUE);
	
}
////////////////////////////////////////////////////////////////////////
//Functon:File reference call back function.
///////////////////////////////////////////////////////////////////////
void CALLBACK FileRefDone(DWORD nReserved,DWORD nUser)
{
	CPlayerDlg* pOwner=(CPlayerDlg*)nUser;
	pOwner->m_bFileRefCreated=TRUE;
	pOwner->ChangeUI();
	TRACE("File reference created!\n");

}
//////////////////////////////////////////////////////////////////////////
//Function:Change UI when the file ref call back function is called.
//////////////////////////////////////////////////////////////////////////
void CPlayerDlg::ChangeUI()
{
	if(m_bFileRefCreated)
	{
		CButton *pButton;
		pButton = (CButton *)GetDlgItem(IDC_STEPBACK);
		pButton->EnableWindow(TRUE);
		
		m_pMainMenu->EnableMenuItem(ID_CUT_FILE,MF_ENABLED);
		m_pMainMenu->EnableMenuItem(ID_SEEK,MF_ENABLED);
	}
}
///////////////////////////////////////////////////////////////////////////
//Function:Redraw the image when move window.
///////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	
	// TODO: Add your message handler code here
	PlayM4_RefreshPlay(PORT);
}
///////////////////////////////////////////////////////////////////////////
//Function:Get the info.
///////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnInfo() 
{
	// TODO: Add your command handler code here
	CInfo infoDlg;
	infoDlg.DoModal();
}
//////////////////////////////////////////////////////////////////////////
//Function: Locate the file position by frame number or time.
/////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnSeek() 
{
	// TODO: Add your command handler code here
	m_pSeek->Create(IDD_SEEK);
	m_pMainMenu->EnableMenuItem(ID_SEEK,MF_GRAYED);
}

/////////////////////////////////////////////////////////////////////////
//Function:Close the seek dialog .
/////////////////////////////////////////////////////////////////////////
void CPlayerDlg::SeekOk(WPARAM wParam, LPARAM lParam)
{
	m_pSeek->DestroyWindow();
	m_pMainMenu->EnableMenuItem(ID_SEEK,MF_ENABLED);
}
/////////////////////////////////////////////////////////////////////////
//Funtion: Cut the file;
/////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnCutFile() 
{
	// TODO: Add your command handler code here
	CCutFile cutDlg;
	if(cutDlg.SetFileName(m_strPlayFileName))
		cutDlg.DoModal();

}
///////////////////////////////////////////////////////////////////////
//Function : throw B-Frame.
/////////////////////////////////////////////////////////////////
void CPlayerDlg::OnThrow0() 
{
	// TODO: Add your command handler code here
	PlayM4_ThrowBFrameNum(PORT,0);
	CheckThrowBFrame(ID_THROW0);

}

void CPlayerDlg::OnThrow1() 
{
	// TODO: Add your command handler code here
	PlayM4_ThrowBFrameNum(PORT,1);
	CheckThrowBFrame(ID_THROW1);

}

void CPlayerDlg::OnThrow2() 
{
	// TODO: Add your command handler code here
	PlayM4_ThrowBFrameNum(PORT,2);
	CheckThrowBFrame(ID_THROW2);

}

void CPlayerDlg::CheckThrowBFrame(UINT nMenuID)
{
	for(UINT nID=ID_THROW0;nID<=ID_THROW2;nID++)
		m_pMainMenu->CheckMenuItem(nID,MF_UNCHECKED);
	m_pMainMenu->CheckMenuItem(nMenuID,MF_CHECKED);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void CPlayerDlg::OnDisnormal() 
{
	// TODO: Add your command handler code here
	CheckDisplayType(ID_DISNORMAL);	
	PlayM4_SetDisplayType(PORT,DISPLAY_NORMAL);
}

void CPlayerDlg::OnDisquarter() 
{
	// TODO: Add your command handler code here
	CheckDisplayType(ID_DISQUARTER);	
	PlayM4_SetDisplayType(PORT,DISPLAY_QUARTER);
}

void CPlayerDlg::CheckDisplayType(DWORD nID)
{
	m_pMainMenu->CheckMenuItem(ID_DISNORMAL,MF_UNCHECKED);
	m_pMainMenu->CheckMenuItem(ID_DISQUARTER,MF_UNCHECKED);
	m_pMainMenu->CheckMenuItem(nID,MF_CHECKED);
}

void CPlayerDlg::OnSetDisplay() 
{
	// TODO: Add your command handler code here
	m_pDisplayRegion->Create(IDD_RANGE);
	m_pMainMenu->EnableMenuItem(ID_SETDISPLAY,MF_GRAYED);
}
void CPlayerDlg::DisplayOk(WPARAM wParam, LPARAM lParam)
{
	m_pDisplayRegion->DestroyWindow();
	m_pMainMenu->EnableMenuItem(ID_SETDISPLAY,MF_ENABLED);
}
void CPlayerDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CRect rcShow;
	GetDlgItem(IDC_SHOW)->GetWindowRect(rcShow);
	ScreenToClient(rcShow);

	if(rcShow.PtInRect(point))
	{
		m_StartPoint=point;
		m_bStartDraw=TRUE;
		InvalidateRect(m_rcDraw,TRUE);
		ZeroMemory(&m_rcDraw,sizeof(m_rcDraw));
		
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CPlayerDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(m_bStartDraw)
	{
		if(m_StartPoint!=point)
		{

			CRect rcShow;
			GetDlgItem(IDC_SHOW)->GetWindowRect(rcShow);
			ScreenToClient(rcShow);
			
			if(rcShow.PtInRect(point)&&point.x>=m_StartPoint.x&&point.y>=m_StartPoint.y)
			{
				m_rcDraw.left= m_StartPoint.x;
				m_rcDraw.top = m_StartPoint.y;
				m_rcDraw.right= point.x;
				m_rcDraw.bottom= point.y;
				
				CDC* pDC=GetDC();
				pDC->DrawFocusRect(m_rcDraw);
				ReleaseDC(pDC);
			
				LONG nPicWidth=352;
				LONG nPicHeight=288;
				PlayM4_GetPictureSize(PORT,&nPicWidth,&nPicHeight);
				m_rcDisplay=GetOnPicRect(rcShow,m_rcDraw,nPicWidth,nPicHeight);

				if(m_pDisplayRegion->m_hWnd)
					m_pDisplayRegion->PostMessage(WM_DISPLAY_RECT,0,(long)(&m_rcDisplay));
			}

			
		}
		m_bStartDraw=FALSE;
	}
	
	CDialog::OnLButtonUp(nFlags, point);
}

CRect CPlayerDlg::GetOnPicRect(CRect rcWnd,CRect rcOnWnd,LONG nPicWidth,LONG nPicHeight)
{
	CRect rcOnPic;
	//LONG nScaleX=rcWnd.Width()
	long nWndX=rcOnWnd.left-rcWnd.left;
	long nWndY=rcOnWnd.top-rcWnd.top;
	if(nWndX<0)
		nWndX=0;
	if(nWndY<0)
		nWndY=0;

	rcOnPic.left = nWndX*nPicWidth/rcWnd.Width();
	rcOnPic.top = nWndY*nPicHeight/rcWnd.Height();
	rcOnPic.right = rcOnPic.left+rcOnWnd.Width()*nPicWidth/rcWnd.Width();
	rcOnPic.bottom = rcOnPic.top+rcOnWnd.Height()*nPicHeight/rcWnd.Height();
	
	if(rcOnPic.right>nPicWidth)
		rcOnPic.right=nPicWidth;
	if(rcOnPic.bottom>nPicHeight)
		rcOnPic.bottom=nPicHeight;
	
	return rcOnPic;
}

void CPlayerDlg::OnTimer1() 
{
	// TODO: Add your command handler code here
	PlayM4_SetTimerType(PORT,TIMER_1,0);
	m_pMainMenu->CheckMenuItem(ID_TIMER1,MF_CHECKED );
	m_pMainMenu->CheckMenuItem(ID_TIMER2,MF_UNCHECKED );
}

void CPlayerDlg::OnTimer2() 
{
	// TODO: Add your command handler code here
	PlayM4_SetTimerType(PORT,TIMER_2,0);
	m_pMainMenu->CheckMenuItem(ID_TIMER2,MF_CHECKED );
	m_pMainMenu->CheckMenuItem(ID_TIMER1,MF_UNCHECKED );
}

void CPlayerDlg::OnResetBuf() 
{
	// TODO: Add your command handler code here
	//Only test the interface. 
	PlayM4_ResetBuffer(PORT,BUF_VIDEO_RENDER);
	PlayM4_ResetBuffer(PORT,BUF_AUDIO_RENDER);
	PlayM4_ResetBuffer(PORT,BUF_VIDEO_SRC);
	PlayM4_ResetBuffer(PORT,BUF_AUDIO_SRC);
}
void CALLBACK VerifyFun(long nPort, FRAME_POS * pFilePos, DWORD bIsVideo,  DWORD nUser)
{
//	TRACE("File have been changed at: pos = 0x%X; time(s) = %d, frameNum = %d; IsVideo = %d\n",
//		pFilePos->nFilePos, pFilePos->nFrameTime/1000, pFilePos->nFrameNum, bIsVideo);
	CString abstime;
	CString str;
	if (pFilePos->pErrorTime )
	{
		abstime.Format("%02d-%02d-%02d %02d:%02d:%02d",pFilePos->pErrorTime->wYear,pFilePos->pErrorTime->wMonth,
			pFilePos->pErrorTime->wDay,pFilePos->pErrorTime->wHour,pFilePos->pErrorTime->wMinute,pFilePos->pErrorTime->wSecond);
	}
	str.Format("file error at pos=0x%X, time(s) =%d,frameNum=%d,isVideo=%d, \
		errorframe at%d,lostframe=%d,lostdata=%d,time=%s\n",	\
		pFilePos->nFilePos,pFilePos->nFrameTime/1000,pFilePos->nFrameNum,bIsVideo,	\
		pFilePos->nErrorFrameNum,pFilePos->nErrorLostFrameNum,pFilePos->nErrorFrameSize,abstime);
	TRACE(str); 
}
void CALLBACK WaveCBFun(long nPort, char * pAudioBuf, long nSize, long nStamp, long nType, long nUser)
{
	//TRACE("Wave data, nPort = %d, nSize = %d, nStamp = %d, nType = %d\n", nPort, nSize, nStamp, nType);
}

void CPlayerDlg::OnConvertToAVI() 
{
	// TODO: Add your command handler code here
	
	m_pMainMenu->EnableMenuItem(ID_FILE_CLOSE, TRUE);
	m_pMainMenu->EnableMenuItem(ID_FILE_OPEN, TRUE);
	int ReturnValue;
	CString str,m_csInfo;
	str.Format("Convert  to AVI File will be Failed to Play the MPEG4 File\n\n");
	m_csInfo+=str;
	str.Format("The Converted AVI File can't be Larger than 2G!\n\n");
	m_csInfo+=str;
	str.Format("Playing the Converted AVI File must Install the Divx!\n\n");
	m_csInfo+=str;
	str.Format("if Continued,Click OK Button!\n");
    m_csInfo+=str;
	ReturnValue=MessageBox((LPCTSTR)m_csInfo,NULL,MB_YESNO); 
	if(ReturnValue==IDYES)
	{
       m_bConvert=1;
	   CString csFileExtFilter= "AVI Movie Files (*.avi)|*.avi||";
	   
	   CFileDialog Filedlg(FALSE,"*.avi","*.avi",OFN_LONGNAMES|OFN_CREATEPROMPT|OFN_OVERWRITEPROMPT,csFileExtFilter,this);
	   if(Filedlg.DoModal()==IDOK)
	   {
		   szFileName=Filedlg.GetPathName();
		   
		   OnFileOpen();
	   }
	}
	if(ReturnValue==IDNO)
	   m_bConvert=0;    

	m_bFirst=false;
	m_bFirstWrite=false;
	frameNum=0;

    CButton *pButton;
	pButton = (CButton *)GetDlgItem(IDC_PLAY);		
	//pButton->SetIcon(m_hPlayEnableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_PAUSE);		
	pButton->SetIcon(m_hPauseDisableIcon);
	pButton->EnableWindow(FALSE);

	//pButton = (CButton *)GetDlgItem(IDC_STOP);		
//	pButton->SetIcon(m_hStopDisableIcon);
	//pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_FAST);		
	pButton->SetIcon(m_hFastForwardDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_SLOW);		
	pButton->SetIcon(m_hFastBackwardDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOEND);	
	pButton->SetIcon(m_hGotoEndDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_GOTOSTART);	
	pButton->SetIcon(m_hGotoStartDisableIcon);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STEP);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_STEPBACK);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_CAPPIC);
	pButton->EnableWindow(FALSE);

	pButton = (CButton *)GetDlgItem(IDC_SOUND);
	pButton->EnableWindow(FALSE);

	CSliderCtrl* pSlider;
	pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERB);
	pSlider->EnableWindow(FALSE);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERC);
	pSlider->EnableWindow(FALSE);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERS);
	pSlider->EnableWindow(FALSE);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_SLIDERH);
	pSlider->EnableWindow(FALSE);

	pSlider=(CSliderCtrl*)GetDlgItem(IDC_PLAY_SLIDER);
	pSlider->EnableWindow(FALSE);
}

bool writeHeaders()
{
	MainAVIHeader		 mainAviHeader;
	AVIStreamHeader		 aviStreamHeader;
	BITMAPINFOHEADER	 bitmapHeader;
	DWORD fcc;
	riffAddList( outFile, "RIFF", "AVI " );
	//
	// Write hdr1 list
	//
	riffAddList( outFile, "LIST", "hdrl" );
	mainAviHeader.dwMicroSecPerFrame		= 1000000 / fps;
	mainAviHeader.dwMaxBytesPerSec			= maxFrameSize + PADDING_GRANULARITY;	// Spare
	mainAviHeader.dwPaddingGranularity		= 0;
	mainAviHeader.dwFlags					= AVIF_HASINDEX;
	mainAviHeader.dwTotalFrames				= numFrames;
	mainAviHeader.dwInitialFrames			= 0;
	mainAviHeader.dwStreams					= 1;
	mainAviHeader.dwSuggestedBufferSize		= maxFrameSize + PADDING_GRANULARITY;	// Spare
	mainAviHeader.dwWidth					= frameWidth;
	mainAviHeader.dwHeight					= frameHeight;
	mainAviHeader.dwReserved[0]				= 0;
	mainAviHeader.dwReserved[1]				= 0;
	mainAviHeader.dwReserved[2]				= 0;
	mainAviHeader.dwReserved[3]				= 0; 

	riffAddChunk( outFile, "avih" );
	riffWriteData( outFile, &mainAviHeader, sizeof( mainAviHeader ) );
	riffCloseChunk( outFile );
	//
	// Write the "strl" video list
	//
	riffAddList( outFile, "LIST", "strl" );
	//
	// Write the "strh" chunk	

	fcc = mmioFOURCC( 'Y', 'V', '1', '2' );
	aviStreamHeader.fccType					= mmioFOURCC( 'v', 'i', 'd', 's' );
	aviStreamHeader.fccHandler				= 0;
	aviStreamHeader.dwFlags					= fcc;
	aviStreamHeader.wPriority				= 0;
	aviStreamHeader.wLanguage				= 0;
	aviStreamHeader.dwInitialFrames			= 0;
	aviStreamHeader.dwScale					= 1;
	aviStreamHeader.dwRate					= fps;
	aviStreamHeader.dwStart					= 0;
	aviStreamHeader.dwLength				= numFrames;
	aviStreamHeader.dwSuggestedBufferSize	= maxFrameSize + PADDING_GRANULARITY;
	aviStreamHeader.dwQuality				= 0xFFFFFFFF;				// -1
	aviStreamHeader.dwSampleSize			= 0;
	aviStreamHeader.dwTop					= 0;
	aviStreamHeader.dwLeft					= 0;
	aviStreamHeader.dwRight					= 0;
	aviStreamHeader.dwBottom				= 0;


	riffAddChunk( outFile, "strh" );
	riffWriteData( outFile, &aviStreamHeader, sizeof( aviStreamHeader ) );
	riffCloseChunk( outFile );
//
	//
	// Write the "strf" chunk
	//
	bitmapHeader.biSize				= sizeof( bitmapHeader );
	bitmapHeader.biWidth			= frameWidth;
	bitmapHeader.biHeight			= frameHeight;
	bitmapHeader.biPlanes			= 1;
	bitmapHeader.biBitCount			= 12;
	bitmapHeader.biCompression		= fcc;
	bitmapHeader.biSizeImage		= outputFrameSize;
    bitmapHeader.biXPelsPerMeter	= 0;
    bitmapHeader.biYPelsPerMeter	= 0;
	bitmapHeader.biClrUsed			= 0;
	bitmapHeader.biClrImportant		= 0;
    
	riffAddChunk( outFile, "strf" );
	riffWriteData( outFile, &bitmapHeader, sizeof( bitmapHeader ) );
	riffCloseChunk( outFile );      

	//
	// Close the strl list
	//
	riffCloseList( outFile );

	//
	// Close the hdrl list
	//
	riffCloseList( outFile );
	//
	// Write JUNK chunk
	//
	riffPadJunk( outFile, PADDING_GRANULARITY, 0 );
	//
	// Write the "movi" list
	//
	riffAddList( outFile, "LIST", "movi" );
	firstFrameOffset = riffSize( outFile );
	moviOffset = firstFrameOffset - 4;
	//
	// Return
	//
	return true;
}

bool addFileToAVI(long frameNumber)
{
#ifdef WRITE_REC_LIST

	//
	// Write "rec " list
	//
#ifdef WRITE_INDEX

	riffPadWord( outFile );

#endif // WRITE_INDEX

	riffAddList( outFile, "LIST", "rec" );

#endif // WRITE_REC_LIST
//
	// Write the "00dc" chunk
	//
#ifdef WRITE_INDEX

	riffPadWord( outFile );

#endif // WRITE_INDEX

	indexes[frameNumber].ckid			= mmioFOURCC( '0', '0', 'd', 'c' );
	indexes[frameNumber].dwFlags		= AVIIF_KEYFRAME;
	indexes[frameNumber].dwChunkOffset	= riffSize( outFile ) - moviOffset;
	indexes[frameNumber].dwChunkLength	= outputFrameSize;

	//
	// Translate the YUV to YVU9
	//
	//translateYUV();    

	//
	// Write the translated chunk
	//
	riffAddChunk( outFile, "00dc" );

    riffWriteData(outFile, yuvBuf, outputFrameSize);
	
	riffCloseChunk( outFile );

#ifdef WRITE_REC_LIST

	//
	// Close the "rec " list
	//
	riffCloseList( outFile );

#endif // WRITE_REC_LIST

	//
	// Write JUNK chunk to align video frames
	//
#ifdef ALIGN_VIDEO_FRAMES

	riffPadJunk( outFile, PADDING_GRANULARITY, firstFrameOffset );

#endif // ALIGN_VIDEO_FRAMES

	return true;
}

bool closeWriffFiles()
{
	//
	// Close the "movi" list
	//
	riffCloseList( outFile );
    
	//
	// Write the "idx1" chunk
	//
#ifdef WRITE_INDEX

	riffPadWord( outFile );
	riffAddChunk( outFile, "idx1" );
	riffWriteData( outFile, indexes, numFrames*sizeof( AVIINDEXENTRY ) );
	riffCloseChunk( outFile );

#endif // WRITE_INDEX

	//
	// Close the "RIFF" LIST
	//
	riffCloseList( outFile );
    
	//
	// Close the riff file
	//
	riffClose( outFile );

	//
	// Close the input file
	//
	//fclose( inFile );

	return true;
}

