// ProVisionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"
#include "SelectDSP.h"
#include "settingsDlg.h"
#include "alarmfile.h"
#include "promptdlg.h"
#include "csetupdec.h"
#include "boardlist.h"
#include "videowin.h"

#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <stdio.h>
#include <mmsystem.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

int SplitRects(int width, int height, int cols, int rows, RECT *rectList);

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProVisionDlg dialog

CProVisionDlg::CProVisionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProVisionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProVisionDlg)
	m_brightness = 0;
	m_contrast = 0;
	m_hue = 0;
	m_saturation = 0;
	m_iframes = 0;
	m_pbframes = 0;
	m_lostframes = 0;
	m_audioframes = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProVisionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProVisionDlg)
	//DDX_Control(pDX, IDC_LOGWIN, m_Logwin);
	DDX_Slider(pDX, IDC_SLIDER_BRIGHT, m_brightness);
	DDX_Slider(pDX, IDC_SLIDER_CONTRAST, m_contrast);
	DDX_Slider(pDX, IDC_SLIDER_HUE, m_hue);
	DDX_Slider(pDX, IDC_SLIDER_SAT, m_saturation);
	DDX_Text(pDX, IDC_IFRAMES, m_iframes);
	DDX_Text(pDX, IDC_PBFRAMES, m_pbframes);
	DDX_Text(pDX, IDC_LOST_FRAMES, m_lostframes);
	DDX_Text(pDX, IDC_AUDIOFRAMES, m_audioframes);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProVisionDlg, CDialog)
	//{{AFX_MSG_MAP(CProVisionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CTLCOLOR()
	ON_WM_SHOWWINDOW()
	ON_WM_MOVE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_SETTINGS, OnSettings)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CAPIMAGE, OnCapimage)
	ON_BN_CLICKED(IDC_AUDIO_PREVIEW, OnAudioPreview)
	ON_BN_CLICKED(IDC_VIDEO_PREVIEW, OnVideoPreview)
	ON_BN_CLICKED(IDC_CAPIFRAME, OnCapiframe)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_SUBSTOP, OnSubstop)
	ON_BN_CLICKED(IDC_BUTTON5, OnStartImageCap)
	ON_BN_CLICKED(IDC_BUTTON6, OnStopImageCap)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_REGISTERED_MESSAGE(MsgUpdateCounters, OnUpdateCounters)
	ON_REGISTERED_MESSAGE(MsgDataReady, OnDataReady)
	ON_BN_CLICKED(IDC_SERIAL, OnSerial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()





/////////////////////////////////////////////////////////////////////////////
// CProVisionDlg message handlers
int LogWrite(const char *Format, ...);

HANDLE ChannelHandle[MAX_CHANNELS];
int    logFile;
int    gFileHandle[MAX_CHANNELS];
BOOLEAN dlgInited = FALSE;
HWND gMainWnd;
RECT rectList[MAX_CHANNELS +1];
BOOL bDdrawMode =FALSE;
ULONG   gChannelFrames[MAX_CHANNELS];
LARGE_INTEGER   gChannelTotalLength[MAX_CHANNELS];
ULONG	gChannelFramesLost[MAX_CHANNELS];
ULONG	gChannelOverflow[MAX_CHANNELS];
ULONG	gCurrentFileLen[MAX_CHANNELS];
ULONG	gCaptureStartedNum = 0;
ULONG	gSignleCaptureNum = 0;
UINT    gTimer;
UINT    gCapImages;
ULONG	gFileSize = 100; 
int		gFileNum = 0;
int		gIFrameFileHandle;
AlarmFile alarmFile[64];
BOOL    bAlarmFileSave = FALSE;
BOOL bWriteToDisk = FALSE;			///hhh1120
BOOL bStartCapture = FALSE;
BOOL bTestData  = FALSE;
BOOL bAudioPre=FALSE;	//ƵʵʱԤ
BOOL bOverlayMode=FALSE;//SetPreviewOverlayModeķֵΪ0bOverlayModeֵΪTRUEʾOverlayʽԤ

COLORREF gBackgroundColor = RGB(10, 10, 10);

int __cdecl StreamReadCallback(ULONG ChannelNum, void *Context);
typedef int (*STREAM_DIRECT_READ_CALLBACK)(ULONG channelNumber,void *DataBuf,DWORD Length,int FrameType,void *context);
int __cdecl StreamDirectReadCallback(ULONG channelNumber,void *DataBuf,DWORD Length,int FrameType,void *context);

void ImageStreamCallback(UINT channelNumber,void *Context);

extern int iLastSelect;
extern int iOldSelect;

ULONG StartTime;
ULONG LastTime;
extern CPromptDlg promptDlg;
static 	UINT testVideo[64], testAudio[64];
unsigned char StreamBuf[1000000];
//unsigned int motionData[MAX_CHANNELS][18];
unsigned char motionData[MAX_CHANNELS][1600];
///add ver3.4 by h
// qcif file handle while subChannel encoding cif and qcif 
int    gFileHandleQcif[MAX_CHANNELS];					
// qcif file header while subChannel encoding cif and qcif
unsigned char FileHeaderQcif[MAX_CHANNELS][200];		
// subChannel encoding cif and qcif
BOOL bEncodeCifAndQcif[MAX_CHANNELS];					
static HPEN penWhite = CreatePen(PS_SOLID,	1,RGB(255,255,255));
extern int DisplayMode ;

void CALLBACK DrawFun(long nport, HDC hDc,LONG nUser)
{
	CProVisionDlg *pOwner = (CProVisionDlg*)nUser;
	if (nport == iLastSelect  ) //&& DisplayMode != 1)
	{
		if (DisplayMode != 1)
		{
			int weight,height;
			weight = rectList[iLastSelect].right - rectList[iLastSelect].left;
			height = rectList[iLastSelect].bottom- rectList[iLastSelect].top;
			HGDIOBJ pOldPen = ::SelectObject(hDc,&penWhite);
			::MoveToEx(hDc,		1,  1,	NULL);
			::LineTo(hDc,		weight -1, 1);
			::LineTo(hDc,		weight -1,height-1);
			::LineTo(hDc,		1,height -1);
			::LineTo(hDc,		1,1);
			::SelectObject(hDc,pOldPen);
		}
		CString str;
		str.Format("channel%d",nport);
		SetTextColor(hDc, RGB(255,0,0));
		SetBkMode(hDc,TRANSPARENT);
		TextOut(hDc,10,10,str,str.GetLength());

		if(pOwner->m_bMoving[nport])
		{
			pOwner->m_VideoWin.DrawVect(nport,(char *)motionData[nport],hDc,pOwner->chstandard[nport]);
			pOwner->m_bMoving[nport] = FALSE;
		}
	}
	else
		pOwner->StopDrawFun(nport);
	return;

}

BOOL CProVisionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	m_brush1.CreateSolidBrush(gBackgroundColor);   
	m_brush2.CreateSolidBrush(RGB(0,0,0));   
	m_bLog = FALSE;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_brightness = 50;
	m_contrast = 50;
	m_hue = 0;
	m_saturation = 50;
	m_iframes = 0;
	m_pbframes = 0;
	m_audioframes = 0;
	m_lostframes = 0;
	
	m_bSwitchMetrix=FALSE;

	UpdateData(FALSE);

	m_VideoWin.SubclassDlgItem(IDC_VIDEOWIN, this);

	if(InitDSPs() <= 0){
		//afxDump<<"error:can not init DSPs\n";
		AfxMessageBox("can not init DSPs\n");
		return FALSE;
	}

	int iReturn=-1;
//ݺSetPreviewOverlayModeķֵжϵǰԿǷ֧OverlayʽԤ
//0ʾֵ֧֣ʾ֧	
	iReturn=SetPreviewOverlayMode(TRUE);
	TRACE("iReturn=%04x\n",iReturn);
	if(iReturn==0)
	{
		bOverlayMode=TRUE;
	}
	for(int i = 0; i < GetTotalDSPs(); i++){
		m_bDspPreset[i] = TRUE;
		bEncodeCifAndQcif[i] = FALSE;
	}
	

	for(i = 0; i < GetTotalDSPs(); i++){
		m_bDspPreset[i] = TRUE;
		bEncodeCifAndQcif[i] = FALSE;
	}
	
	dlgInited = TRUE;

	for(i = 0; i < GetTotalDSPs(); i++){
		ChannelHandle[i] = ChannelOpen(i);
		testVideo[i] = testAudio[i] =0;
		m_bMoving[i] = FALSE;
		RegisterDrawFun(i, DrawFun ,(DWORD)this);
	}
	int bright, contrast, sat, hue;
	for(i = 0; i < GetTotalDSPs(); i++)
	{
		GetVideoPara(ChannelHandle[i], &chstandard[i], &bright, &contrast, &sat, &hue);
	}

///add v34
//Channel0 now encoding cif and qcif, and having two subChannel  
//we can use SetupSubChannel() to config subchannel0(cif) and subchannel1(qcif)
//	SetEncoderPictureFormat(ChannelHandle[0], ENC_CIFQCIF_FORMAT);
//	bEncodeCifAndQcif[0] = TRUE;
//Channel1 now is encoding 2cif
//	if (GetTotalDSPs() >=2)
//		SetEncoderPictureFormat(ChannelHandle[1], ENC_2CIF_FORMAT);
	//SetEncoderPictureFormat(ChannelHandle[0], ENC_QCIF_FORMAT);
	//SetEncoderPictureFormat(ChannelHandle[1], ENC_2CIF_FORMAT);
	//SetEncoderPictureFormat(ChannelHandle[2], ENC_QCIF_FORMAT);
	//SetEncoderPictureFormat(ChannelHandle[3], ENC_QCIF_FORMAT);

//	SetupNotifyThreshold(ChannelHandle[0], 3);

	//SetVideoStandard(ChannelHandle[2], StandardNTSC);

	//int id = IDC_CHECK2;
	//for(i = 0; i < MAX_CHANNELS; i++){
	//	GetDlgItem(id + i)->EnableWindow(FALSE);
	//}
	
	logFile = _open("log.txt", _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
	if(logFile == -1){
		AfxMessageBox("can not open log file\n");
		return FALSE;
	}
	RegisterStreamDirectReadCallback(::StreamDirectReadCallback,this);
	RegisterMessageNotifyHandle(m_hWnd, MsgDataReady);
//	RegisterStreamReadCallback(::StreamReadCallback, this);
	RegisterImageStreamCallback(ImageStreamCallback,this);

	gCapImages = 0;

/*	VERSION_INFO verInfo;
	GetSDKVersion(&verInfo);
	CString verStr;
	verStr.Format(" dsp ver%04x build%04x driver ver%04x build04%x sdk version%04x build%04x",
		verInfo.DspVersion, verInfo.DspBuildNum, verInfo.DriverVersion, verInfo.DriverBuildNum, 
		verInfo.SDKVersion, verInfo.SDKBuildNum);

	CString title;
	CString dsps;
	dsps.Format(" build(0701) %d DSPs Found", GetTotalDSPs());
	GetWindowText(title);
	title += dsps + verStr;
	SetWindowText(title);*/

	SetOverlayColorKey(gBackgroundColor);

	gTimer = SetTimer(1, 1000, 0);

//	SetTimer(2,5000,0);
	promptDlg.ShowWindow(SW_HIDE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CProVisionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CProVisionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CProVisionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



int LogWrite(const char *Format, ...)
{

	CHAR	Buffer0[1024];
	CHAR	Buffer1[512];
	DWORD	ItemsWritten;
	va_list	ArgumentList;

	if(logFile == -1)return -1;

	SYSTEMTIME sysTime;
	GetLocalTime(&sysTime);

	sprintf(Buffer0, "%02d%02d:%02d:%02d:%02d:", sysTime.wMonth, sysTime.wDay, sysTime.wHour, 
		sysTime.wMinute, sysTime.wSecond);

	va_start ( ArgumentList, Format ); 
	ItemsWritten = vsprintf ((char *)Buffer1, Format, ArgumentList );
	va_end ( ArgumentList );
	strcat(Buffer0, Buffer1);

	return _write ( logFile, Buffer0, strlen((const char *)Buffer0 ));
}


void CProVisionDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	CSelectDSP selDialog;
	selDialog.DSPPreset(m_bDspPreset, GetTotalDSPs());

	if(selDialog.DoModal() == IDOK){
		TRACE("SelectDSP:OK button clicked\n");
		selDialog.GetDSPsChoiced(m_bDspPreset);

		CString str;
		str.Format("%d", 0);
		GetDlgItem(IDC_LOST_FRAMES)->SetWindowText((LPCTSTR)str);
		GetDlgItem(IDC_TOTALFRAMES)->SetWindowText((LPCTSTR)str);
		GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)str);
		GetDlgItem(IDC_FPS)->SetWindowText((LPCTSTR)str);

		LogWrite("start capture\r\n"); 
//add v34
//		SetupSubChannel(ChannelHandle[0], 1);						//change to  sub channel
//		SetBitrateControlMode(ChannelHandle[0],  brCBR );			//setttings
//		SetupBitrateControl(ChannelHandle[0], 128000);	
//		SetupSubChannel(ChannelHandle[0], 0);						//change to main channel

		for(int i = 0; i < GetTotalDSPs(); i++){
			if(m_bDspPreset[i]){
				char fileName[256];
				CTime m_StartTime1=CTime::GetCurrentTime();
				CString csStartTime=m_StartTime1.Format("%Y%m%d%H%M%S");
				sprintf(fileName, "ch%02d_%s.264", i,csStartTime);

				gFileHandle[i] = _open(fileName, _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
				if(gFileHandle[i] == -1){
					TRACE("file open error\n");
					AfxMessageBox("can not open file\n");
					return;
				}
///add v34
				if (bEncodeCifAndQcif[i])
				{
					sprintf(fileName, "stream_sub_%d_%d.264", i, gFileNum++);
					gFileHandleQcif[i] = _open(fileName, _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
					if(gFileHandleQcif[i] == -1){
						TRACE("file open error\n");
						AfxMessageBox("can not open file\n");
						return;
					}
				}
				gChannelFrames[i] = 0;
				gChannelTotalLength[i].QuadPart = 0;
				gChannelFramesLost[i] = 0;
				gChannelOverflow[i] = 0;
				gCurrentFileLen[i] = 0;
				StartVideoCapture(ChannelHandle[i]);	
				// could not be start again untill stopped first
				//m_bDspPreset[i] = FALSE;
				gCaptureStartedNum++;
				// let the threads have chance to run
				//Sleep(500);
			}else
				gFileHandle[i] = -1;
			// note:must bigger than keyframeintervals
			alarmFile[i].Reset();

			//			ǶSetup()˵
			//			һ5ʾԤ¼5ӵƵݣƶǰݣҲǱǰ
			//			ڶЧͬʱint AlarmFile::Trigger(int fileHandle)
			//				if(startWrite){
			//					framesToWriteImmediatly = framesToStopWrite;
			//					canStopWrite = FALSE;
			//				}
			//			һδΣھݵüοص
			//			int __cdecl StreamDirectReadCallback(ULONG channelNum,void *DataBuf,DWORD Length,int frameType,void *context)
			//			if(bAlarmFileSave)
			//
			//
			alarmFile[i].Setup(5*(25+25), 0); 

		}
		StartTime = timeGetTime();
		LastTime = timeGetTime();
		bStartCapture = TRUE;
		if(gCaptureStartedNum){
			GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
			GetDlgItem(IDC_START)->EnableWindow(FALSE);
			//GetDlgItem(IDC_SETTINGS)->EnableWindow(FALSE);
		}
	}
}

void CProVisionDlg::LogMessage(const unsigned char *buf, void *context)
{
	if(!IsWindow(this->m_hWnd))return;

	int len = m_Logwin.GetWindowTextLength();

	CString str;
	 
	if (len >= 16384)
	{
		m_Logwin.GetWindowText(str);
		m_Logwin.SetWindowText(str.GetBuffer(len)+16384);
		len -= 16384;
	}

	str = buf;

	m_Logwin.SetSel(len, len);

	m_Logwin.ReplaceSel(str);

}

void CProVisionDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	m_bLog = FALSE;
	OnButton11();
	KillTimer(gTimer);
	KillTimer(m_MatrixSwitch);
	if (bAudioPre)	//close
	{
		for(int i=0; i < GetTotalDSPs(); i++)
		{
			SetAudioPreview(ChannelHandle[i],FALSE);
		}
		bAudioPre = FALSE;
	}

	if(gCaptureStartedNum)
		OnStop();

	StopVideoPreview();
	for(int i= 0 ;i < GetTotalDSPs(); i++)
	{
		ChannelClose(ChannelHandle[i]);
	}
	gCaptureStartedNum = 0;

	DeInitDSPs();	


	_close(logFile);
	CDialog::OnClose();
}



void CProVisionDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	CSelectDSP selDialog;
	selDialog.DSPPreset(m_bDspPreset, GetTotalDSPs());

	if(selDialog.DoModal() == IDOK)
	{	LogWrite("Stop capture\r\n");
		TRACE("SelectDSP:OK button clicked\n");
		selDialog.GetDSPsChoiced(m_bDspPreset);
		for(int i = 0; i < GetTotalDSPs(); i++){
			if(m_bDspPreset[i]){
				ASSERT(gFileHandle[i] != -1);
				StopVideoCapture(ChannelHandle[i]);
				//lseek(gFileHandle[i], 0, SEEK_SET);
				//FRAMES_STATISTICS fs;
				//GetFramesStatistics(ChannelHandle[i], &fs);
				//ULONG frames = fs.AudioFrames + fs.VideoFrames;
				//TRACE("channel %i has %x frames written\n", i, frames);
#define END_CODE 0x00000002
				ULONG endCode = END_CODE;
				_write(gFileHandle[i], &endCode, sizeof(ULONG));
				_close(gFileHandle[i]);
				gFileHandle[i] = 0;
///add v34
				if (bEncodeCifAndQcif[i])
				{
					_close(gFileHandleQcif[i]);
					gFileHandleQcif[i] =0;
				}
				gCaptureStartedNum--;
			}
		}
	
		bStartCapture = FALSE;
//		bTestData = FALSE;
		if(!gCaptureStartedNum){
			GetDlgItem(IDC_START)->EnableWindow(TRUE);
			//GetDlgItem(IDC_SETTINGS)->EnableWindow(TRUE);
			GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
		}
	}
}

void CProVisionDlg::StartVideoPreview()
{
	RECT rc;
	GetClientRect(&rc);
	//::StartVideoPreview(ChannelHandle[0], GetDlgItem(IDC_VIDEOWIN)->m_hWnd, &rc, FALSE, vdfYUV422Planar, 25);
}

void CProVisionDlg::StopVideoPreview()
{
	TRACE("StopVideoPreview\n");
	for(int i = 0; i < GetTotalDSPs(); i++){
		::StopVideoPreview(ChannelHandle[i]);
	}
}

void CProVisionDlg::OnPreview() 
{
	// TODO: Add your control notification handler code here
	static BOOLEAN bVideoStarted = FALSE;
	if(bVideoStarted){
		StopVideoPreview();
		bVideoStarted = FALSE;
	}else{
		StartVideoPreview();
		bVideoStarted = TRUE;
	}
}




HBRUSH CProVisionDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	// TODO: Change any attributes of the DC here
	if((nCtlColor== CTLCOLOR_EDIT) && (pWnd->GetDlgCtrlID() == IDC_EDIT1)){
		pDC->SetTextColor (RGB (255, 0 , 0));
		pDC->SetBkColor(gBackgroundColor);
		hbr = (HBRUSH) m_brush1;
	}

	if((nCtlColor== CTLCOLOR_EDIT) && (pWnd->GetDlgCtrlID() == IDC_LOGWIN)){
		pDC->SetTextColor (RGB (255, 0 , 0));
		pDC->SetBkColor(RGB(0, 0, 0));
//		pDC->SetBkColor(RGB(255, 0, 255));
		hbr = (HBRUSH) m_brush2;
	}
	
	// TODO: Return a different brush if the default is not desired
	return hbr;
}

void CProVisionDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	TRACE("Onshowwindow m_hwnd is %x\n", m_hWnd);

	m_bLog = TRUE;


}

void CProVisionDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);

	if(!dlgInited)return;  
	
	// TODO: Add your message handler code here

	::SendMessage(GetDlgItem(IDC_VIDEOWIN)->m_hWnd, WM_PAINT, 0, 0);

	
}


void CProVisionDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CProVisionDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	static int bright=128, contrast=64, sat=64, hue=0;
//	VideoStandard_t standard;
	int i;
	
	if((GetDlgItem(IDC_SLIDER_BRIGHT) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		/*for(int i = 0; i < GetTotalDSPs(); i++)*/{
			if(iLastSelect == -1)
				i = 0;
			else i = iLastSelect;
			bright = (nPos * 255) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}

	if((GetDlgItem(IDC_SLIDER_CONTRAST) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		/*for(int i = 0; i < GetTotalDSPs(); i++)*/{
			if(iLastSelect == -1)
				i = 0;
			else i = iLastSelect;
			contrast = (nPos * 127) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}

	if((GetDlgItem(IDC_SLIDER_SAT) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		/*for(int i = 0; i < GetTotalDSPs(); i++)*/{
			if(iLastSelect == -1)
				i = 0;
			else i = iLastSelect;
			sat = (nPos * 127) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}

	if((GetDlgItem(IDC_SLIDER_HUE) == pScrollBar) && (nSBCode != SB_ENDSCROLL)){
		/*for(int i = 0; i < GetTotalDSPs(); i++)*/{
			if(iLastSelect == -1)
				i = 0;
			else i = iLastSelect;
			hue = (nPos * 255) / 100;
			TRACE("b=%i c=%i s=%i h=%i\n", bright, contrast, sat, hue);
			SetVideoPara(ChannelHandle[i], bright, contrast, sat, hue);
		}
	}


	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}





int CProVisionDlg::OnUpdateCounters(UINT wparam, INT lparam)
{
	CString str;
	str.Format("%i", wparam);
	GetDlgItem(IDC_IFRAMES)->SetWindowText((LPCTSTR)str);
	
	return 0;
}



void CProVisionDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnLButtonDown(nFlags, point);
}


unsigned char FileHeader[64][200];
int FileHeaderLen;


int  GetIdFromPacket(int frameType,	UCHAR *StreamBuf);
int CProVisionDlg::OnDataReady(UINT channelNum, INT lparam)
{
	ULONG length = 500000;
	int frameType;
	int status;
	BOOL breakable;
	static BOOL iframefileOpened = FALSE;
	int nframetype =0;
	// TRACE("OnDataReady\n");
	// if cap images we need clean the queue here
//	if(!gCaptureStartedNum && !gSignleCaptureNum) 
//		return 0;
//	do
//	{
		length = 1000000;
	 status = ReadStreamData(ChannelHandle[channelNum], StreamBuf,  &length, &frameType);
	 // error occured
	 if(status < 0){
		 TRACE("error:ReadStreamData %x\n", status);
		 LogWrite("channel %d ReadStreamData error , code=%x\r\n", channelNum, status);
		 return 0;
	 }
///add v34 
// nframetype value:	 1 cif head; 2 qcif head; 3 cif frame; 4 qcif frame; 5 audio frame; 0 others
//we must process stream separate while encoding cif and qcif at same time
//stream of cif is saved to cif files, qcif's saved to qcif files, audio stream is saved to all
	 if (bEncodeCifAndQcif[channelNum])
		nframetype = GetSubChannelStreamType(&StreamBuf,frameType);


	 breakable = status;
	 // no errors
	 if(frameType > 0) {
		 if(frameType == PktSysHeader){
			 if (bEncodeCifAndQcif[channelNum])
			 {
				 if (nframetype == 1)  //get cif file header
				 {
					memcpy(FileHeader[channelNum],StreamBuf,length);
					FileHeaderLen = length;
				 }
				 else if (nframetype ==2)	//get qcif or qqcif file header
				 {
					memcpy(FileHeaderQcif[channelNum], StreamBuf, length);
					TRACE("Ch%02d get Qcifhead or QQcifhead!\n",channelNum);
					FileHeaderLen = length;
				 }
			 }
			 else
			 {
				 // store the file header
				 memcpy(FileHeader[channelNum], StreamBuf, length);
				 FileHeaderLen = length;
				 //return 0;
			 }
		 }
		 if(frameType == PktMotionDetection){
			int result[4];
			// channel 1 set as qcif encoding
			// others set as cif encoding
			//if(channelNum == 0)
//				m_VideoWin.DrawVect(channelNum, (char *)StreamBuf);
			//else 
			m_bMoving[channelNum] = TRUE;
			memcpy(motionData[channelNum], StreamBuf,length);
//			TRACE("motion data received\n");

			 MotionAnalyzer(ChannelHandle[channelNum], (char *)StreamBuf, 2, result);
			 
			 if((result[0] + result[1] + result[2] + result[3])){
				 if (channelNum ==0)
					TRACE("CH=%d motion detect result %d %d %d %d\n", channelNum,result[0], result[1], result[2], result[3]);
				 alarmFile[channelNum].Trigger(gFileHandle[channelNum]);
			 }
			 return 0;
		 }
		 if((frameType == PktSFrames) && gSignleCaptureNum){
			 // single i frame
			 TRACE("iframe cap\n");
			 if(!iframefileOpened){
				 gIFrameFileHandle = _open("iframe.264", _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
				 _write(gIFrameFileHandle, FileHeader[channelNum], FileHeaderLen);
				 iframefileOpened = TRUE;
			 }
			 _write(gIFrameFileHandle, StreamBuf, length);
			 gSignleCaptureNum--;
			 // Note:this frame should be store in the normal file
		 }

	 }
//	 else
//		 return 0;
 
	 if(length == 0){
		 TRACE("no data ?\n");
		 return 0;
	 }
//	DWORD ID = GetIdFromPacket(frameType,	StreamBuf);


	ULONG currentTime = timeGetTime();

///add v34 
	if (bEncodeCifAndQcif[channelNum] )
	{
		if (nframetype ==3  || nframetype ==5)     //we just sum cif file length 
		{
			gChannelTotalLength[channelNum].QuadPart += length;
			gCurrentFileLen[channelNum] += length;
		}
	}
	else
	{
		gChannelTotalLength[channelNum].QuadPart += length;
		gCurrentFileLen[channelNum] += length;
	}

	if(ULONG s = (currentTime - StartTime)/1000){
		CString str;
		if(iLastSelect != -1)
			str.Format("%d", (gChannelTotalLength[iLastSelect].QuadPart /s)*8);
		else 
			str.Format("%d", (gChannelTotalLength[0].QuadPart /s)*8);

		//GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)str);
	}

	if((gCurrentFileLen[channelNum] > gFileSize * 1000 * 1000) && breakable && bStartCapture){
		TRACE("switch file:frametype=%x\n", frameType);
		_close(gFileHandle[channelNum]);
//add v34, qcif file close
		if (bEncodeCifAndQcif[channelNum])
			_close(gFileHandleQcif[channelNum]);
		// create new file
		char fileName[256];
		CTime m_StartTime1=CTime::GetCurrentTime();
		CString csStartTime=m_StartTime1.Format("%Y%m%d%H%M%S");
		sprintf(fileName, "ch%02d_%s.264", channelNum,csStartTime);
		gFileHandle[channelNum] = _open(fileName, _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
		// write the header first
		_write(gFileHandle[channelNum], FileHeader[channelNum], FileHeaderLen);
//add v34, qcif file create
		if (bEncodeCifAndQcif[channelNum])
		{
			sprintf(fileName, "ch%02d_%s_sub.264", channelNum,csStartTime);
			gFileHandleQcif[channelNum] = _open(fileName, _O_CREAT | _O_BINARY | _O_WRONLY| _O_TRUNC, _S_IREAD | _S_IWRITE);
			// write the header first
			_write(gFileHandleQcif[channelNum], FileHeaderQcif[channelNum], FileHeaderLen);
		}
		gCurrentFileLen[channelNum] -= gFileSize * 1000 * 1000;
	}

	if(bAlarmFileSave){
		if(frameType == PktSysHeader)
			_write(gFileHandle[channelNum], StreamBuf, length);
		else if (bEncodeCifAndQcif[channelNum])
		{
			if (nframetype ==3 || nframetype ==5)   ///add v34
				alarmFile[channelNum].FramePush(gFileHandle[channelNum], StreamBuf,  \
										  length, (FrameType_t)frameType, breakable);
		}
		else
		{
			alarmFile[channelNum].FramePush(gFileHandle[channelNum], StreamBuf,  \
										  length, (FrameType_t)frameType, breakable);
		}
	}else {

		if(frameType ==PktAudioFrames)
		{
			_write(gFileHandle[channelNum],StreamBuf,length);
			_write(gFileHandleQcif[channelNum],StreamBuf,length);
			
		}else if (frameType ==PktSubIFrames || frameType ==PktSubPFrames || frameType == PktSubBBPFrames || frameType == PktSubSysHeader)
		{
			
			_write(gFileHandleQcif[channelNum],StreamBuf,length);
			
		}else 
		{
			_write(gFileHandle[channelNum],StreamBuf,length);
			
		}
	}

//	}while(length != 0);

	return 0;
}

void CProVisionDlg::OnSettings() 
{
	// TODO: Add your control notification handler code here
	
	CSettingsDlg dlg;

	int i=0;
	USHORT Format1[] = {24, 240, _OSD_YEAR2, '-',_OSD_MONTH2,'-',_OSD_DAY,'-',  _OSD_HOUR24, ':', _OSD_MINUTE,':', _OSD_SECOND, '\0'};
	USHORT Format2[] = { 0, 0, 0x20, 0};
	USHORT Format3[8][44] = {{2, 2, '0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j',\
		'k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','\0'},
				{2, 25, '0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j',\
				'k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','\0'},
				{2, 50, 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t',\
				'u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9','\0'},
				{2, 75, 'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t',\
				'u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9','\0'},
				{2, 100, _OSD_YEAR4, '-',_OSD_MONTH2,'-',_OSD_DAY,'-',_OSD_HOUR24,':',_OSD_MINUTE,':',_OSD_SECOND,'-',_OSD_MONTH3,'-',_OSD_WEEK3,'','',_OSD_CWEEK1,_OSD_HOUR12,'\0'},
				{2, 125, 'P','r','o','V','i','d','e','o','\0'},
				{2, 150, 'M','u','l','t','i','m','e','d','i','a','\0'},{2,175,'D','S','-','4','0','x','x','H','C','\0'}};
	USHORT *Format4[8];
	for(i=0;i<8;i++)
	{
		Format4[i]=Format3[i];
	}

	PictureFormat_t encodeType,subEncodeType ; 
	

	int nResponse = dlg.DoModal();

	if (nResponse == IDOK){
		TRACE("quant = %d file size = %d streamType = %d\n",
			dlg.m_Quant, dlg.m_FileSize , dlg.m_StreamType);

	    if (dlg.m_iX >=0 && dlg.m_iY >=0)
			SetInputVideoPosition(ChannelHandle[0],dlg.m_iX,dlg.m_iY);
//set main channel encode type
			switch(dlg.m_iEncodeType)
			{
			case 0:
				encodeType = ENC_CIF_FORMAT;
				break;
			case 1:
				encodeType = ENC_4CIF_FORMAT;
				break;
			case 2:
				encodeType = ENC_QCIF_FORMAT;
				break;
			case 3:
				encodeType = ENC_2CIF_FORMAT;
				break;
			case 4:
				encodeType = ENC_DCIF_FORMAT;
				break;
			default:
				encodeType = ENC_CIF_FORMAT;
				break;
			}
		
			for(i = 0; i < GetTotalDSPs(); i++)
			{
				if(encodeType != ENC_4CIF_FORMAT)
				{					
					SetEncoderPictureFormat(ChannelHandle[i],encodeType);
				}
				else if ((i%4==0)||(i%4==1))
				{					
					SetEncoderPictureFormat(ChannelHandle[i],encodeType);
				}
			}
//set sub channel encode type
			switch(dlg.m_iSubEncodeType)
			{
			case 0:
				subEncodeType = ENC_CIF_FORMAT;
				break;
			case 1:
				subEncodeType = ENC_4CIF_FORMAT;
				break;
			case 2:
				subEncodeType = ENC_QCIF_FORMAT;
				break;
			case 3:
				subEncodeType = ENC_2CIF_FORMAT;
				break;
			case 4:
				subEncodeType = ENC_DCIF_FORMAT;
				break;
			default:
				subEncodeType = ENC_CIF_FORMAT;
				break;
			}
			for(i = 0; i < GetTotalDSPs(); i++)
			{
				SetSubEncoderPictureFormat(ChannelHandle[i],subEncodeType);
			}

		// setup quant value 
		for(i = 0; i < GetTotalDSPs(); i++)
		{
			SetDefaultQuant(ChannelHandle[i], dlg.m_iQuant, dlg.m_pQuant, dlg.m_bQuant);
		}

		if(dlg.m_OsdEnable){
			for(i = 0; i < GetTotalDSPs(); i++){
				SetOsdDisplayMode(ChannelHandle[i], 255, TRUE, 1, Format1, Format2);
//	show osd with 8 rows			
//				SetOsdDisplayModeEx(ChannelHandle[i], 255, TRUE, 1, 8, Format4);
				SetOsd(ChannelHandle[i], TRUE);
			}
		}else {
			for(i = 0; i < GetTotalDSPs(); i++){
				SetOsd(ChannelHandle[i], FALSE);
			}
		}

		if(dlg.m_IFramesIntervals  < 12){
			AfxMessageBox("Invalid Key Frames Invervals\n");
			return;
		}else{
			if((dlg.m_FrameRate > 30) || (dlg.m_FrameRate <=0))
				dlg.m_FrameRate = 30;
			for( i = 0; i < GetTotalDSPs(); i++){
				SetIBPMode(ChannelHandle[i], dlg.m_IFramesIntervals, 2, 1, dlg.m_FrameRate);
			}
		}

		bAlarmFileSave = FALSE;
		if(dlg.m_MotionDetect){
			bAlarmFileSave = TRUE;
			
			for( i = 0; i < GetTotalDSPs(); i++){
				// user may dynamicly adjust motion detect precisions	
				//˶ȵȼ0x80000000,Ӧ
				VideoStandard_t videostandard;
				int bright,constrast,sat,hue;
				int bHeight;
				GetVideoPara(ChannelHandle[i],&videostandard,&bright,&constrast,&sat,&hue);
				AdjustMotionDetectPrecision(ChannelHandle[i], 0x80000000|(dlg.m_motionDetectPrec), 2, 0);
				if(videostandard==1)
				{
					bHeight=480;
				}
				else
				{
					bHeight=576;
				}
				RECT areaList[4];
				areaList[0].top = 0; areaList[0].left = 0; 
				areaList[0].right = 704/2; areaList[0].bottom = bHeight/2;
				
				areaList[1].top = 0; areaList[1].left = 704/2; 
				areaList[1].right = 703; areaList[1].bottom = bHeight/2;
				
				areaList[2].top = bHeight/2; areaList[2].left = 0; 
				areaList[2].right = 704/2; areaList[2].bottom = bHeight-1;
				
				areaList[3].top = bHeight/2; areaList[3].left = 704/2; 
				areaList[3].right = 703; areaList[3].bottom = bHeight-1;

				SetupMotionDetection(ChannelHandle[i], areaList, 4);
				StartMotionDetection(ChannelHandle[i]);
			}
		}else{
			for( i = 0; i < GetTotalDSPs(); i++){
				StopMotionDetection(ChannelHandle[i]);
				m_bMoving[i] = FALSE;
			}
		}
		if(dlg.m_bMask)
		{
			int j;
			RECT areaList[32];
			for(i = 0; i < 4; i++)
				for(j =0; j <8; j++)
				{
					areaList[i*8+j].left	= (3*j+1)*16 +200;
					areaList[i*8+j].top		= (3*i+1)*16 +200;
					areaList[i*8+j].right	= (3*j+1)*16 + 32 +200;
					areaList[i*8+j].bottom	= (3*i+1)*16 + 16 +200;
				}
			
			for(i = 0; i < GetTotalDSPs(); i++)
				SetupMask(ChannelHandle[i],areaList, 32);

		}
		else
		{
			for(i = 0; i < GetTotalDSPs(); i++)
				StopMask(ChannelHandle[i]);
		}

		USHORT streamType = STREAM_TYPE_AVSYNC;
		switch(dlg.m_StreamType){
		case 0:
			streamType = STREAM_TYPE_VIDEO;
			break;
		case 1:
			streamType = STREAM_TYPE_AUDIO;
		case 2:
			streamType = STREAM_TYPE_AVSYNC;
			break;
		}

		for(i = 0; i < GetTotalDSPs(); i++){
			SetStreamType(ChannelHandle[i], streamType);
	
		}

		if(dlg.m_logoEnable){

			int w,h;
			unsigned char *bitsBuffer = (unsigned char *)malloc(128 * 128 * 2);

			if(bitsBuffer == NULL)
				return;

			if (LoadYUVFromBmpFile("logo.bmp", bitsBuffer, 128 * 128 * 2,  &w, &h))
			{
				AfxMessageBox("logo.bmp not exsit!\n");
				return;
			}

			for( i = 0; i < GetTotalDSPs(); i++){
				SetLogo(ChannelHandle[i], 0, 0, w, h, (UCHAR *)bitsBuffer);
				SetLogoDisplayMode(ChannelHandle[i], RGB(0,0,0),TRUE, 0);
			}

			free(bitsBuffer);
		}else{
			for( i = 0; i < GetTotalDSPs(); i++){
				StopLogo(ChannelHandle[i]);
			}
		}
		gFileSize = dlg.m_FileSize;

		for(i = 0; i < GetTotalDSPs(); i++){
			SetBitrateControlMode(ChannelHandle[i], dlg.m_CBR ? brCBR : brVBR);
		}

		if(dlg.m_Max_bps > 10000){
			for( i = 0; i < GetTotalDSPs(); i++){
				SetupBitrateControl(ChannelHandle[i], dlg.m_Max_bps);
			}
		}else{
			for( i = 0; i < GetTotalDSPs(); i++){
				SetupBitrateControl(ChannelHandle[i], 0);
			}
		}

	}
}

static DWORD dwNum =0;
void CProVisionDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	// 10 seconds 

	static int bitrateControlInterval = 10;
	static LARGE_INTEGER lastLen[MAX_CHANNELS];

	if(nIDEvent ==1){
//		for(int i = 0; i < GetTotalDSPs(); i++){
//			if(!GetVideoSignal(ChannelHandle[i])){
//				CheckDlgButton(IDC_CHECK2 + i, BST_CHECKED);   
//			}else{
				//TRACE("Channel%d Video lost !\n", i);
//				CheckDlgButton(IDC_CHECK2 + i, BST_UNCHECKED);   
//			}

//		}

		ULONG Bps = ((gChannelTotalLength[iLastSelect].QuadPart - 
			lastLen[iLastSelect].QuadPart)/1000 ) * 8;

		lastLen[iLastSelect].QuadPart = gChannelTotalLength[iLastSelect].QuadPart;
		
		CString strBps ;
//		strBps.Format("%d", Bps);

//		GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)strBps);
		CString str;
		FRAMES_STATISTICS fs;
		GetFramesStatistics(ChannelHandle[iLastSelect], &fs);
		strBps.Format("%d",fs.CurBps/1024);
		GetDlgItem(IDC_BPS)->SetWindowText((LPCTSTR)strBps);
		if(fs.FramesLost || fs.QueueOverflow){
			if((gChannelFramesLost[iLastSelect] != fs.FramesLost)||
				(gChannelOverflow[iLastSelect] != fs.QueueOverflow)){
				LogWrite("ch%d frame errors:%d-%d\r\n", iLastSelect, fs.FramesLost, fs.QueueOverflow);
				gChannelFramesLost[iLastSelect] = fs.FramesLost;
				gChannelOverflow[iLastSelect] = fs.QueueOverflow;
			}
			if(iLastSelect != -1){
				GetFramesStatistics(ChannelHandle[iLastSelect], &fs);
				str.Format("%d-%d", fs.FramesLost, fs.QueueOverflow);
			}else {
				GetFramesStatistics(ChannelHandle[0], &fs);
				str.Format("%d-%d", fs.FramesLost, fs.QueueOverflow);
			}
			GetDlgItem(IDC_LOST_FRAMES)->SetWindowText((LPCTSTR)str);
		}

		ULONG currentTime = timeGetTime();
		str.Format("%d", fs.VideoFrames + fs.AudioFrames);
		GetDlgItem(IDC_IFRAMES)->SetWindowText((LPCTSTR)str);
		ULONG s = (currentTime - StartTime)/1000;
		if(s != 0){
			str.Format("%2.1f-%2.1f", (float)fs.AudioFrames/s, (float)fs.VideoFrames/s);
			GetDlgItem(IDC_FPS)->SetWindowText((LPCTSTR)str);
		}
//		TRACE("slevel=%d\n", GetSoundLevel(ChannelHandle[iLastSelect]));
	}
	else if (nIDEvent ==1010)
	{

		int iArea;
		int iDecNum=0;
		
		if(m_bSwitchMetrix)
		{
			
			dwNum ++;
			if ( dwNum %5==0)
				iArea =1;
			else if (dwNum %5 ==1)
				iArea =4;
			else if (dwNum %5 ==2)
				iArea =16;
			else if (dwNum %5 ==3)
				iArea =2;
			else if (dwNum %5 ==4)
				iArea =3;
		}

		SetupRegion(iDecNum,iArea);
			
		
	}
	CDialog::OnTimer(nIDEvent);
}
static int   itimes = 0;
void CProVisionDlg::OnCapimage() 
{
	// TODO: Add your control notification handler code here
	UCHAR imageBuf[704 * 576*2];
	DWORD Size = 704 * 576*2;
	UCHAR *imageBuffer=new UCHAR[Size];
	char fileName[256];
	CTime m_StartTime1=CTime::GetCurrentTime();
	CString csStartTime=m_StartTime1.Format("%Y%m%d%H%M%S");
//	int ret;
	int jpegQuality=100;
	
	{
		//capture BMP picture
		TRACE("start original image cap\n");
		sprintf(fileName, "ch%02d_%s.bmp", iLastSelect,csStartTime);
		GetOriginalImage(ChannelHandle[iLastSelect], imageBuf, &Size);
		if(Size == 704  *576 * 2)
			SaveYUVToBmpFile(fileName, imageBuf, 704, 576);
		else if(Size == 704 * 480* 2)
			SaveYUVToBmpFile(fileName, imageBuf, 704, 480);
		if(Size == 352  *288 * 2)
			SaveYUVToBmpFile(fileName, imageBuf, 352, 288);
		else if(Size == 352 * 240* 2)
			SaveYUVToBmpFile(fileName, imageBuf, 352, 240);
		if(Size == 176  *144 * 2)
			SaveYUVToBmpFile(fileName, imageBuf, 176, 144);
		else if(Size == 176 * 120* 2)
			SaveYUVToBmpFile(fileName, imageBuf, 176, 120);
		
		//capture jpg picture				
		if(!imageBuffer)
			return;
		Size = 704 * 576*2;
		int ret=GetJpegImage(ChannelHandle[iLastSelect],imageBuffer,&Size,jpegQuality);
		if(ret==0)
		{
			CString str;
			str.Format("ch%02d_%s.jpg",iLastSelect,csStartTime);
			FILE *pFile=fopen(str.GetBuffer(0),"wb");
			if(pFile)
			{
				fwrite(imageBuffer,Size,1,pFile);
				fclose(pFile);
			}
			else
				AfxMessageBox("Can not open JPEG file!");
		}
		else if(ret==ERR_OUTOF_MEMORY)
			AfxMessageBox("Not enough memory to store bitstream! \n or \n Image is too complex!");
		else if(ret==ERR_WAIT_TIMEOUT)
			AfxMessageBox("System is too busy!");
		delete []imageBuffer;
		Sleep(10);
	}
	
}

void CProVisionDlg::OnAudioPreview() 
{
	// TODO: Add your control notification handler code here
	if (bAudioPre)	//close
	{
		GetDlgItem(IDC_AUDIO_PREVIEW)->SetWindowText("StartAuPre");
		for(int i=0; i < GetTotalDSPs(); i++)
		{
			SetAudioPreview(ChannelHandle[i],FALSE);
		}
		bAudioPre = FALSE;
	}
	else
	{
		for(int i=0; i < GetTotalDSPs(); i++)
		{
			SetAudioPreview(ChannelHandle[i],FALSE);
		}
		
		SetAudioPreview(ChannelHandle[iLastSelect],TRUE);
		GetDlgItem(IDC_AUDIO_PREVIEW)->SetWindowText("StopAuPre");
		bAudioPre = TRUE;
	}
}


 


void CProVisionDlg::OnVideoPreview() 
{
	// TODO: Add your control notification handler code here
	CSelectDSP selDialog;
	selDialog.DSPPreset(m_bDspPreset, GetTotalDSPs());

	m_VideoWin.CacRects(GetTotalDSPs());

	if(selDialog.DoModal() == IDOK){
		TRACE("SelectDSP:OK button clicked\n");
		selDialog.GetDSPsChoiced(m_bDspPreset);
		for(int i = 0; i < GetTotalDSPs(); i++){
			if(m_bDspPreset[i])
				::StartVideoPreview(ChannelHandle[i], /*GetDlgItem(IDC_VIDEOWIN)->m_hWnd*/m_hWnd, &rectList[i], FALSE, vdfYUV422Planar, 25);
			else
				::StopVideoPreview(ChannelHandle[i]);
		}
	}
}

void CProVisionDlg::OnCapiframe() 
{
	// TODO: Add your control notification handler code here

	gSignleCaptureNum++;

	CaptureIFrame(ChannelHandle[iLastSelect]);

}
	


BOOL CProVisionDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.style = WS_EX_TOPMOST|WS_POPUP ; 
	return CDialog::PreCreateWindow(cs);
}



int __cdecl StreamReadCallback(ULONG ChannelNum, void *Context)
{
	CProVisionDlg *prodlg = (CProVisionDlg *)Context;
	prodlg->OnDataReady(ChannelNum, 0);
	return 0;
}


//typedef int (*STREAM_DIRECT_READ_CALLBACK)(ULONG channelNumber,void *DataBuf,DWORD Length,int FrameType,void *context);
int __cdecl StreamDirectReadCallback(ULONG channelNum,void *DataBuf,DWORD Length,int frameType,void *context)
{

	BOOL breakable;

	int nframetype =0;
	CProVisionDlg *prodlg = (CProVisionDlg *)context;

	if(frameType >0)
	{
		if (frameType == PktSysHeader)
		{
			memcpy(FileHeader[channelNum],DataBuf,Length);
			FileHeaderLen = Length;
		}
		else if (frameType == PktSubSysHeader)
		{
			memcpy(FileHeaderQcif[channelNum],DataBuf,Length);
			FileHeaderLen = Length;
		}
		if (frameType == PktMotionDetection)
		{
			int result[4];

			if(bOverlayMode)
			{
				prodlg->m_VideoWin.DrawVectEx(channelNum, (char *)DataBuf);
			}
			else
			{
				prodlg->m_bMoving[channelNum] = TRUE;
				memcpy(motionData[channelNum],(char*)DataBuf,Length);
			}
			
			MotionAnalyzer(ChannelHandle[channelNum],(char*)DataBuf,15,result);
			if((result[0] + result[1] + result[2] + result[3]))
			{
				if (channelNum ==0)
					TRACE("!!!!!!!!!!!!!!!!CH=%d motion detect result is %d %d %d %d\n",channelNum,result[0],\
					result[1],result[2],result[3]);
				// TriggerǰѱǰݰsetupãӦľǰ֡дļ
				if(!prodlg->baftermotion[channelNum])
					alarmFile[channelNum].Trigger(gFileHandle[channelNum]);
				//ÿƶ֡Զualreadywriteframes[channelNum]Ϊ0 Ϊд뾯֡׼
				prodlg->ualreadywriteframes[channelNum]=0;
				prodlg->baftermotion[channelNum]=TRUE;
			}
			return 0;
		}
		if (frameType == PktIFrames || frameType ==PktSubIFrames)
			breakable = TRUE;
		else
			breakable = FALSE;

	}
	gChannelTotalLength[channelNum].QuadPart +=Length;
	gCurrentFileLen[channelNum] +=Length;
	if ((gCurrentFileLen[channelNum] > gFileSize*1000*1000) && (breakable) )
	{
		char fileName[256];
		CTime m_StartTime1=CTime::GetCurrentTime();
		CString csStartTime=m_StartTime1.Format("%Y%m%d%H%M%S");
		
		
		if (gFileHandle[channelNum])
		{
			_close(gFileHandle[channelNum]);
			sprintf(fileName, "ch%02d_%s.264", channelNum,csStartTime);
			gFileHandle[channelNum] = _open(fileName,_O_CREAT|_O_BINARY|_O_WRONLY|_O_TRUNC,_S_IREAD|_S_IWRITE);
			_write(gFileHandle[channelNum],FileHeader[channelNum],FileHeaderLen);
		}
		if (gFileHandleQcif[channelNum])
		{
			_close(gFileHandleQcif[channelNum]);
			sprintf(fileName, "ch%02d_%s_sub.264", channelNum,csStartTime);
			gFileHandleQcif[channelNum] = _open(fileName,_O_CREAT|_O_BINARY|_O_WRONLY|_O_TRUNC,_S_IREAD|_S_IWRITE);
			_write(gFileHandleQcif[channelNum],FileHeaderQcif[channelNum],FileHeaderLen);
		}
		gCurrentFileLen[channelNum] -=gFileSize*1000*1000;
	}
	if(bAlarmFileSave)
	{
		if(frameType == PktSysHeader)
			_write(gFileHandle[channelNum],DataBuf,Length);
		else
		{
			//ͳƶ֮֡Ƶݣͳ дļÿһ µƶ
			//ualreadywriteframes0ȻͳдļƵ
			prodlg->ualreadywriteframes[channelNum] += prodlg->TypeToFrames((FrameType_t)frameType);
			if (prodlg->ualreadywriteframes[channelNum] <6*(25+25)) //¼ƶ֮֡ 6ӵƵݣҲǾ
				_write(gFileHandle[channelNum],DataBuf,Length);
			else
			{
				//  ƶ֮дļƵѾ㹻ôѽƵѹ壬
				//  ѹ뻺ִʽˣԶɾΪ´αľǰ֡дļ
				alarmFile[channelNum].FramePush(gFileHandle[channelNum],(unsigned char *)DataBuf,Length,(FrameType_t)frameType,breakable);
				prodlg->baftermotion[channelNum] = FALSE;
			}
		}
	}
	else
		{
			if(frameType ==PktAudioFrames)
			{
				_write(gFileHandle[channelNum],DataBuf,Length);
				_write(gFileHandleQcif[channelNum],DataBuf,Length);
								
			}else if (frameType ==PktSubIFrames || frameType ==PktSubPFrames || frameType == PktSubBBPFrames || frameType == PktSubSysHeader)
			{
				
				_write(gFileHandleQcif[channelNum],DataBuf,Length);
				
			}else 
			{
				_write(gFileHandle[channelNum],DataBuf,Length);
				
			}
		}
		return 0;
}

void CProVisionDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	for(int i=0; i < GetTotalChannels(); i++)
	{
		char fileName[256];
		CTime m_StartTime1=CTime::GetCurrentTime();
		CString csStartTime=m_StartTime1.Format("%Y%m%d%H%M%S");
		sprintf(fileName, "ch%02d_%s_sub.264", i,csStartTime);
		gFileHandleQcif[i]= _open(fileName,_O_CREAT|_O_BINARY|_O_WRONLY|_O_TRUNC,_S_IREAD|_S_IWRITE);
		if(gFileHandleQcif[i] ==-1)
		{
			TRACE("file Open error!\n");
			AfxMessageBox("can not open file!\n");
			return ;
		}
		SetSubStreamType(ChannelHandle[i],STREAM_TYPE_AVSYNC);
//		SetSubEncoderPictureFormat(ChannelHandle[i],ENC_CIF_FORMAT);
		SetupSubChannel(ChannelHandle[i],1);// switch to sub channel for setting
		SetBitrateControlMode(ChannelHandle[i], brVBR );
		SetupBitrateControl(ChannelHandle[i],2000000);
		SetDefaultQuant(ChannelHandle[i], 16, 16, 18);
		SetIBPMode(ChannelHandle[i],100,2,2,25);
		StartSubVideoCapture(ChannelHandle[i]);
		SetupSubChannel(ChannelHandle[i],0);//switch to main channel
	}
	GetDlgItem(IDC_SUBSTART)->EnableWindow(FALSE);
	GetDlgItem(IDC_SUBSTOP)->EnableWindow(TRUE);
}

void CProVisionDlg::OnSubstop() 
{
	// TODO: Add your control notification handler code here
	for(int i=0; i < GetTotalChannels(); i++)
	{
		StopSubVideoCapture(ChannelHandle[i]);
		_close(gFileHandleQcif[i]);
		gFileHandleQcif[i] = 0;
	}
	GetDlgItem(IDC_SUBSTART)->EnableWindow(TRUE);
	GetDlgItem(IDC_SUBSTOP)->EnableWindow(FALSE);
	
}

void CProVisionDlg::StopDrawFun(DWORD nport)
{
	StopRegisterDrawFun(nport);

}

#define WIDTH	704
#define HEIGHT	576
#define  nSize WIDTH*HEIGHT*3/2
static BOOL bFirstCapimage = TRUE;
static FILE *pImageFile = NULL;
unsigned char imageBuf[nSize];
static UINT count=0;
static ULONGLONG imageSize =0;

void ImageStreamCallback(UINT channelNumber,void * Context)
{
	if(pImageFile)
	{
		printf("Demo have received image!channel:%u\n",channelNumber);
		fwrite(imageBuf,1,HEIGHT*WIDTH*3/2,pImageFile);
		imageSize +=WIDTH*HEIGHT*3/2;
		if (imageSize >=100*1000*1000)
		{
			fclose(pImageFile);
			if (count >=300)
				count =0;
			char name[50];
			sprintf(name,"image%02u_%04u.yuv",0,count++);
			pImageFile=fopen(name,"wb");
			imageSize =0;
		}
	}
	else
		printf("error open file\n");
	Sleep(1);
}

void CProVisionDlg::OnStartImageCap() 
{
	// TODO: Add your control notification handler code here
		if (bFirstCapimage)
	{
		char name[50];
		sprintf(name,"image%02u_%04u.yuv",0,count++);
		pImageFile=fopen(name,"wb");
		bFirstCapimage = FALSE;
	}
	printf("SetImageStream start\n");
	SetImageStream(ChannelHandle[0],1,0,WIDTH,HEIGHT,imageBuf);

	if(!bFirstCapimage){
			GetDlgItem(IDC_BUTTON5)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON6)->EnableWindow(TRUE);
			}
	return ;
}

void CProVisionDlg::OnStopImageCap() 
{
	// TODO: Add your control notification handler code here
	printf("SetImageStream stop\n");
	SetImageStream(ChannelHandle[0],0,0,0,0,0);
	bFirstCapimage = TRUE;
	fclose(pImageFile);
	count =0;
	if(bFirstCapimage){
			GetDlgItem(IDC_BUTTON5)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON6)->EnableWindow(FALSE);
			}
	return ;
}

void CProVisionDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	CCSetupDec dlg;
	int iArea ;
	int iDecNum=0;//һ뿨ĵ0·Ƶ
	if (dlg.DoModal() ==IDOK)
	{
	
		if (dlg.m_Previewtype==0)
			iArea =1;
		else if (dlg.m_Previewtype ==1)
			iArea =4;
		else if (dlg.m_Previewtype==2)
			iArea =16;
		else if (dlg.m_Previewtype==3)
			iArea =2;
		else if (dlg.m_Previewtype ==4)
			iArea =3;
	}

	SetupRegion(iDecNum,iArea);

	
}

void CProVisionDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	CCSetupDec dlg;
	int iArea ;
	int iDecNum=1;//һ뿨ĵ1·Ƶ
	if (dlg.DoModal() ==IDOK)
	{
	
		if (dlg.m_Previewtype==0)
			iArea =1;
		else if (dlg.m_Previewtype ==1)
			iArea =4;
		else if (dlg.m_Previewtype==2)
			iArea =16;
		else if (dlg.m_Previewtype==3)
			iArea =2;
		else if (dlg.m_Previewtype ==4)
			iArea =3;
	}
	
	SetupRegion(iDecNum,iArea);
	
}

void CProVisionDlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	if(!m_bSwitchMetrix)
	{
		m_bSwitchMetrix =TRUE ;
		m_MatrixSwitch=SetTimer(1010,1000,NULL);
		GetDlgItem(IDC_BUTTON10)->SetWindowText((LPCTSTR)"Stop Matrix Switch");
	}
	else
	{
		m_bSwitchMetrix =FALSE;
		KillTimer(1010);
		GetDlgItem(IDC_BUTTON10)->SetWindowText((LPCTSTR)"Start Matrix Switch");
	}
}



void CProVisionDlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	KillTimer(m_MatrixSwitch);
	for (int i=0;i<4;i++)
	{
		for(int j=0;j<64;j++){
			SetEncoderVideoExtOutput(j,0,0,i,i,0);
		}
	}
	ClearDisplayRegion(0,0xffffffff);
	ClearDisplayRegion(1,0xffffffff);
	ClearDisplayRegion(2,0xffffffff);
	ClearDisplayRegion(3,0xffffffff);
}

void CProVisionDlg::SetupRegion(int iDecNum, int iArea)
{
	REGION_PARAM param[MAX_DISPLAY_REGION];
	
	memset(param,0,sizeof(param));
	for(int i=0;i<MAX_DISPLAY_REGION;i++)
	{
//		param[i].color=RGB(19,35,236);
		param[i].color=RGB(10,10,10);
		param[i].param=0;
	}
	
	if (iArea ==1)
	{
		param[0].left = 0; param[0].top =0; param[0].width=704; param[0].height =576;
		SetDisplayRegion(iDecNum,1,param,0);
		SetEncoderVideoExtOutput(1+iDecNum*16,0,1,iDecNum,0,0);
		
	}
	else if(iArea ==4)
	{
		param[0].left = 0; param[0].top =0; param[0].width=352; param[0].height =288;
		param[1].left=352; param[1].top=0;	param[1].width=352;	param[1].height=288;
		param[2].left=0;   param[2].top=288;param[2].width=352;	param[2].height=288;
		param[3].left=352; param[3].top=288;param[3].width=352;	param[3].height=288;
		SetDisplayRegion(iDecNum,4,param,0);
			
		//ǴÿһDSPĵһ·ȡCIFԤ뿨
		SetEncoderVideoExtOutput(0+iDecNum*16,0,1,iDecNum,0,0);
		SetEncoderVideoExtOutput(4+iDecNum*16,0,1,iDecNum,1,0);
		SetEncoderVideoExtOutput(8+iDecNum*16,0,1,iDecNum,2,0);
		SetEncoderVideoExtOutput(12+iDecNum*16,0,1,iDecNum,3,0);
		
	}
	else if(iArea ==16)
	{
		for(int i = 0; i < 4; i++)
		{
			for(int j =0; j <4; j++)
			{
				param[i*4+j].left = j*176;
				param[i*4+j].top = i*144;
				param[i*4+j].width =176;
				param[i*4+j].height =144;
			}
		}
		SetDisplayRegion(iDecNum,16,param,0);
		SetEncoderVideoExtOutput(0+iDecNum*16,0,1,iDecNum,0,0);
		SetEncoderVideoExtOutput(1+iDecNum*16,0,1,iDecNum,1,0);
		SetEncoderVideoExtOutput(2+iDecNum*16,0,1,iDecNum,2,0);
		SetEncoderVideoExtOutput(3+iDecNum*16,0,1,iDecNum,3,0);
		SetEncoderVideoExtOutput(4+iDecNum*16,0,1,iDecNum,4,0);
		SetEncoderVideoExtOutput(5+iDecNum*16,0,1,iDecNum,5,0);
		SetEncoderVideoExtOutput(6+iDecNum*16,0,1,iDecNum,6,0);
		SetEncoderVideoExtOutput(7+iDecNum*16,0,1,iDecNum,7,0);
		SetEncoderVideoExtOutput(8+iDecNum*16,0,1,iDecNum,8,0);
		SetEncoderVideoExtOutput(9+iDecNum*16,0,1,iDecNum,9,0);
		SetEncoderVideoExtOutput(10+iDecNum*16,0,1,iDecNum,10,0);
		SetEncoderVideoExtOutput(11+iDecNum*16,0,1,iDecNum,11,0);
		SetEncoderVideoExtOutput(12+iDecNum*16,0,1,iDecNum,12,0);
		SetEncoderVideoExtOutput(13+iDecNum*16,0,1,iDecNum,13,0);
		SetEncoderVideoExtOutput(14+iDecNum*16,0,1,iDecNum,14,0);
		SetEncoderVideoExtOutput(15+iDecNum*16,0,1,iDecNum,15,0);
	}
	else if(iArea ==2)
	{
		param[0].left = 0; param[0].top =0; param[0].width=704; param[0].height =576;
		param[1].left = 0; param[1].top =0; param[1].width=176; param[1].height =144;
		SetDisplayRegion(iDecNum,2,param,0);
		SetEncoderVideoExtOutput(3+iDecNum*16,0,1,iDecNum,0,0);
		SetEncoderVideoExtOutput(5+iDecNum*16,0,1,iDecNum,1,0);
	}
	else if(iArea ==3)
	{
		param[0].left=0;	param[0].top=0;		param[0].width=704;		param[0].height=288;
		param[1].left=0;	param[1].top=288;	param[1].width=352;		param[1].height=288;
		param[2].left=352;	param[2].top=288;	param[2].width=352;		param[2].height=288;
		SetDisplayRegion(iDecNum,3,param,0);
		SetEncoderVideoExtOutput(7+iDecNum*16,0,1,iDecNum,0,0);
		SetEncoderVideoExtOutput(9+iDecNum*16,0,1,iDecNum,1,0);
		SetEncoderVideoExtOutput(11+iDecNum*16,0,1,iDecNum,2,0);
	}
	

}

void CProVisionDlg::OnSerial() 
{
	// TODO: Add your control notification handler code here
	CBoardList dlg;
	dlg.DoModal();
}

int CProVisionDlg::TypeToFrames(FrameType_t frameType)
{
	switch(frameType){
	case PktIFrames:
	case PktPFrames:
		return 1;
	case PktBBPFrames:
		return 3;
	default:
		return 1;
	}
}





















